---------------------------
---Nova Raid Companion DB--
---------------------------

---NOTE: Some tables here contain some of the same data as others, it's done for lookup speed reasons.
---Better to use slightly more ram with table storage than losing fps.

local addonName, NRC = ...;
if (not NRC.isTBC) then
	return;
end
local L = LibStub("AceLocale-3.0"):GetLocale("NovaRaidCompanion");

NRC.companionCreatures = {
	--Classic.
	[9662] = "Sprite Darter Hatchling",
	[7392] = "Prairie Chicken",
	[8376] = "Mechanical Chicken",
	[15699] = "Tranquil Mechanical Yeti",
	[9657] = "Lil' Smoky",
	[9656] = "Tiny Walking Bomb",
	[12419] = "Lifelike Toad",
	[2671] = "Mechanical Squirrel",
	[7544] = "Crimson Whelpling",
	[7543] = "Dark Whelpling",
	[7545] = "Emerald Whelpling",
	[15429] = "Disgusting Oozeling",
	[7391] = "Hyacinth Macaw",
	[7383] = "Black Tabby",
	[10598] = "Smolderweb Hatchling",
	[10259] = "Worg Pup",
	[7387] = "Green Wing Macaw",
	[7380] = "Siamese",
	[7394] = "Ancona Chicken",
	[7390] = "Cockatiel",
	[7389] = "Senegal",
	[7565] = "Black Kingsnake",
	[7562] = "Brown Snake",
	[7567] = "Crimson Snake",
	[7395] = "Cockroach",
	[14421] = "Brown Prairie Dog",
	[7560] = "Snowshoe Rabbit",
	[7555] = "Hawk Owl",
	[7553] = "Great Horned Owl",
	[7385] = "Bombay",
	[7384] = "Cornish Rex",
	[7382] = "Orange Tabby",
	[7381] = "Silver Tabby",
	[7386] = "White Kitten",
	[16085] = "Peddlefeet",
	[16548] = "Mr. Wiggles",
	[16549] = "Whiskers the Rat",
	[16547] = "Speedy",
	[16701] = "Spirit of Summer",
	[15706] = "Winter Reindeer",
	[15710] = "Tiny Snowman",
	[15705] = "Winter's Little Helper",
	[15698] = "Father Winter's Helper",
	[7550] = "Wood Frog",
	[7549] = "Tree Frog",
	[14878] = "Jubling",
	[11327] = "Zergling",
	[11326] = "Mini Diablo <Lord of Terror>",
	[11325] = "Panda Cub",
	[23713] = "Hippogryph Hatchling",
	[15186] = "Murky",
	[16456] = "Poley",
	[14756] = "Tiny Red Dragon",
	[14755] = "Tiny Green Dragon",
	[15361] = "Murki",
	[16069] = "Gurky",
	[16445] = "Terky", --On wowhead for classic, but WOTLK I think?
	[3619] = "Ghost Saber", --Combat compnaion spawned from an item.
	[17255] = "Hippogryph Hatchling",
	[47687] = "Winna's Kitten", --Felwood quest.
	[15661] = "Baby Shark",
	[9936] = "Corrupted Kitten",
	[17254] = "White Tiger Cub", --Not ingame?
	--[999999999] = "Snapjaw", --Turtle Egg (Albino), never made it into game? No ID found.
	
	--TBC.
	[21055] = "Golden Dragonhawk Hatchling",
	[21064] = "Red Dragonhawk Hatchling",
	[21063] = "Silver Dragonhawk Hatchling",
	[21008] = "Yellow Moth",
	[21010] = "Blue Moth",
	[21018] = "White Moth",
	[21009] = "Red Moth",
	[21056] = "Blue Dragonhawk Hatchling",
	[20472] = "Brown Rabbit",
	[20408] = "Mana Wyrmling",
	[25706] = "Scorchling",
	[23231] = "Willy",
	[23266] = "Peanut",
	[23258] = "Egbert",
	[23909] = "Sinister Squashling",
	[24968] = "Clockwork Rocket Bot",
	[22943] = "Wolpertinger",
	[18839] = "Magical Crawdad",
	[26050] = "Snarly",
	[26056] = "Chuck",
	[24389] = "Muckbreath",
	[24388] = "Toothy",
	[25062] = "Tiny Sporebat",
	[28470] = "Nether Ray Fry",
	[18381] = "Netherwhelp",
	[22445] = "Miniwing",
	[21076] = "Firefly",
	[26119] = "Phoenix Hatchling",
	[24480] = "Mojo",
	[27914] = "Ethereal Soul-Trader",
	[23234] = "Bananas",
	[29089] = "Mini Tyrael",
	[25109] = "Rocket Chicken",
	[27217] = "Spirit of Competition",
	[25110] = "Dragon Kite",
	[23198] = "Lucky",
	[16456] = "Poley",
	[17255] = "Hippogryph Hatchling",
	[27346] = "Essence of Competition",
}

NRC.critterCreatures = {
	[7186] = "A",
	[3300] = "Adder",
	[15475] = "Beetle",
	[10716] = "Belfry Bat",
	[3835] = "Biletoad",
	[2110] = "Black Rat",
	[1932] = "Black Sheep",
	[5740] = "Caged Chicken",
	[5741] = "Caged Rabbit",
	[5743] = "Caged Sheep",
	[5739] = "Caged Squirrel",
	[5742] = "Caged Toad",
	[6368] = "Cat",
	[620] = "Chicken",
	[15066] = "Cleo",
	[13338] = "Core Rat",
	[2442] = "Cow",
	[6827] = "Crab",
	[12299] = "Cured Deer",
	[12297] = "Cured Gazelle",
	[13016] = "Deeprun Rat",
	[883] = "Deer",
	[3444] = "Dig Rat",
	[9658] = "Distract Test",
	[10582] = "Dog",
	[8963] = "Effsee",
	[13017] = "Enthralled Deeprun Rat",
	[5866] = "Equipment Squirrel",
	[5868] = "Evil Squirrel",
	[14892] = "Fang",
	[890] = "Fawn",
	[9699] = "Fire Beetle",
	[1352] = "Fluffy",
	[13321] = "Frog",
	[4166] = "Gazelle",
	[2848] = "Glyx Brewright",
	[5951] = "Hare",
	[385] = "Horse",
	[6653] = "Huge Toad",
	[10780] = "Infected Deer",
	[10779] = "Infected Squirrel",
	[15010] = "Jungle Toad",
	[10541] = "Krakle's Thermometer",
	[15065] = "Lady",
	[16068] = "Larva",
	[9700] = "Lava Crab",
	[16030] = "Maggot",
	[5867] = "Maximum Squirrel",
	[4953] = "Moccasin",
	[6271] = "Mouse",
	[16998] = "Mr. Bigglesworth",
	[12383] = "Nibbles",
	[7208] = "Noarm",
	[582] = "Old Blanchy",
	[9600] = "Parrot",
	[7898] = "Pirate treasure trigger mob",
	[10461] = "Plagued Insect",
	[10536] = "Plagued Maggot",
	[10441] = "Plagued Rat",
	[10510] = "Plagued Slime",
	[12120] = "Plagueland Termite",
	[16479] = "Polymorph Clone",
	[16369] = "Polymorphed Chicken",
	[16779] = "Polymorphed Cow",
	[16373] = "Polymorphed Rat",
	[16372] = "Polymorphed Sheep",
	[2620] = "Prairie Dog",
	[721] = "Rabbit",
	[2098] = "Ram",
	[4075] = "Rat",
	[8881] = "Riding Ram",
	[4076] = "Roach",
	[11776] = "Salome",
	[6145] = "School of Fish",
	[15476] = "Scorpion",
	[1933] = "Sheep",
	[14361] = "Shen'dralar Wisp",
	[12298] = "Sickly Deer",
	[12296] = "Sickly Gazelle",
	[2914] = "Snake",
	[14881] = "Spider",
	[15072] = "Spike",
	[1412] = "Squirrel",
	[5689] = "Steed",
	[10685] = "Swine",
	[10017] = "Tainted Cockroach",
	[10016] = "Tainted Rat",
	[18078] = "The Evil Rabbit",
	[14886] = "The Good Rabbit",
	[1420] = "Toad",
	[14681] = "Transporter Malfunction",
	[15219] = "Trick - Critter",
	[15071] = "Underfoot",
	[12152] = "Voice of Elune",
	[1262] = "White Ram",
	[14801] = "Wild Polymorph Target",
	[3681] = "Wisp",
	[12861] = "Wisp (Ghost Visual Only)",
	
	--TBC critters.
	[20396] = "Captured Critter",
	[22189] = "Marmot",
	[18651] = "Young Blanchy",
	[22480] = "Brown Marmot",
	[25058] = "Fuzz",
	[17970] = "Stormcrow Shape",
	[21034] = "Boar Piglet",
	[17213] = "Broom",
	[23086] = "Sewer Rat",
	[22843] = "Rook",
	[17285] = "Ragnarose",
	[16532] = "Leapgate",
	[23979] = "Giant Marsh Frog",
	[16859] = "Dragonhawk Hatchling",
	[22816] = "Black Cat",
	[20398] = "Reanimated Critter",
	[19665] = "Ewe",
	[20725] = "Bat",
	[21247] = "Oronok's Chicken",
	[19482] = "Sagan",
	[15923] = "Golden Hare",
	[21333] = "[PH]Test Skunk",
	[19941] = "Sagan (Skunk Form)",
	[20411] = "Spectral Bovine",
	[19154] = "Soot",
	[17467] = "Skunk",
	[22306] = "Skittering Cavern Crawler",
	[23087] = "Sewer Crocolisk",
	[22152] = "Ruuan Weald Wisp",
	[25886] = "Doomsday Rat",
	[22842] = "Corvax",
	[26177] = "2.4 Sunwell 5 Man Tradeskill Bunny [PH]",
	[17559] = "Niblet",
	[28100] = "Lemming",
	[21922] = "Talbuk",
};

--Other NPC's to ignore, player pets that have a creature guid, so it doesn't add to creature death counts.
NRC.ignoredCreatures = {
	[23226] = "Illidari Elite",
	[23420] = "Essence of Anger",
	[20062] = "Grand Astromancer Capernian",
	[21271] = "Infinity Blades",
	[20060] = "Lord Sanguinar",
	[20063] = "Master Engineer Telonicus",
	[20064] = "Thaladred the Darkener",
	[19668] = "Shadowfiend",
	[510] = "Water Elemental",
	[19833] = "Venomous Snake", --Snake trap.
	[19921] = "Viper", --Snake trap.
	[1964] = "Treant",
	[15438] = "Greater Fire Elemental",
	[15352] = "Greater Earth Elemental",
	[21160] = "Conjured Water Elemental",
	[17299] = "Crashin' Thrashin' Robot",
	[25305] = "Dancing Flames",
	[24780] = "Field Repair Bot 110G",
	[18846] = "Furious Mr. Pinchy",
	[19405] = "Steam Tonk",
	[15368] = "Tonk Mine",
	[11859] = "Doomguard",
	[14337] = "Field Repair Bot 74A",
};
--Some data taken from from retail EJ_GetCreatureInfo() with adjustments, some extra data manually added, mapped to encounterID.
--JournalEncounterCreature.ID, name, description, displayInfo, iconImage, uiModelSceneID, expansion, zoneID.
NRC.encounters = {
	--Ony.
	[1084] = {"3948", "Onyxia", "", 8570, 1379025, 9, 1, 249},
	--MC.
	[663] = {"3733", "Lucifron", "", 13031, 1378993, 9, 1, 409},
	[664] = {"3734", "Magmadar", "", 10193, 1378995, 9, 1, 409},
	[665] = {"3735", "Gehennas", "", 13030, 1378976, 9, 1, 409},
	[666] = {"3736", "Garr", "", 12110, 1378975, 9, 1, 409},
	[667] = {"3737", "Shazzrah", "", 13032, 1379013, 9, 1, 409},
	[668] = {"3738", "Baron Geddon", "", 12129, 1378966, 9, 1, 409},
	[669] = {"3740", "Sulfuron Harbinger", "", 13030, 1379015, 9, 1, 409},
	[670] = {"3741", "Golemagg the Incinerator", "", 11986, 1378978, 9, 1, 409},
	[671] = {"3742", "Majordomo Executus", "", 12029, 1378998, 9, 1, 409},
	[672] = {"3745", "Ragnaros", "", 11121, 522261, 225, 1, 409},
	--BWL.
	[610] = {"3746", "Razorgore the Untamed", "", 10115, 1379008, 9, 1, 469},
	[611] = {"3747", "Vaelastrasz the Corrupt", "", 13992, 1379022, 9, 1, 469},
	[612] = {"3748", "Broodlord Lashlayer", "", 14308, 1378968, 9, 1, 469},
	[613] = {"3749", "Firemaw", "", 6377, 1378973, 9, 1, 469},
	[614] = {"3750", "Ebonroc", "", 6377, 1378971, 9, 1, 469},
	[615] = {"3751", "Flamegor", "", 6377, 1378974, 9, 1, 469},
	[616] = {"3752", "Chromaggus", "", 14367, 1378969, 9, 1, 469},
	[617] = {"3753", "Nefarian", "", 11380, 1379001, 9, 1, 469},
	--AQ20.
	[718] = {"3754", "Kurinnaxx", "", 15742, 1385749, 9, 1, 509},
	[719] = {"3755", "General Rajaxx", "", 15376, 1385734, 9, 1, 509},
	[720] = {"3756", "Moam", "", 15392, 1385755, 9, 1, 509},
	[721] = {"3757", "Buru the Gorger", "", 15654, 1385723, 9, 1, 509},
	[722] = {"3758", "Ayamiss the Hunter", "", 15431, 1385718, 9, 1, 509},
	[723] = {"3760", "Ossirian the Unscarred", "", 15432, 1385759, 9, 1, 509},
	--AQ40.
	[709] = {"3761", "The Prophet Skeram", "", 15345, 1385769, 9, 1, 531},
	[710] = {"3770", "Lord Kri", "", 15656, 1390436, 9, 1, 531},
	[711] = {"3762", "Battleguard Sartura", "", 15583, 1385720, 9, 1, 531},
	[712] = {"3766", "Fankriss the Unyielding", "", 15743, 1385728, 9, 1, 531},
	[713] = {"3771", "Viscidus", "", 15686, 1385771, 9, 1, 531},
	[714] = {"3767", "Princess Huhuran", "", 15739, 1385761, 9, 1, 531},
	[715] = {"3772", "Emperor Vek'lor", "", 15778, 1390437, 66, 1, 531},
	[716] = {"3774", "Ouro", "", 15509, 1385760, 87, 1, 531},
	[717] = {"3775", "C'Thun", "", 15556, 1385726, 9, 1, 531},
	--ZG (Could be diff encounterIDs on retail? Needs testing on classic).
	[1178] = {"601", "High Priest Venoxis", "", 37788, 522236, 9, 1, 309},
	[1179] = {"602", "Bloodlord Mandokir", "", 37816, 522209, 9, 1, 309},
	[788] = {"603", "Gri'lek", "", 8390, 522230, 9, 1, 309},
	[788] = {"604", "Hazza'rah", "", 37832, 522233, 9, 1, 309},
	[788] = {"605", "Renataki", "", 37830, 522263, 9, 1, 309},
	[788] = {"606", "Wushoolay", "", 37831, 522279, 9, 1, 309},
	[1180] = {"607", "High Priestess Kilnara", "", 37805, 522238, 9, 1, 309},
	[1181] = {"616", "Zanzil", "", 37813, 522280, 9, 1, 309},
	[1182] = {"617", "Jin'do the Godbreaker", "", 37789, 522243, 9, 1, 309},
	--Naxx (Should be diff encounterIDs on retail (wrath)? Needs testing on classic).
	[1107] = {"3853", "Anub'Rekhan", "", 15931, 1378964, 9, 1, 533},
	[1110] = {"3854", "Grand Widow Faerlina", "", 15940, 1378980, 9, 1, 533},
	[1116] = {"3855", "Maexxna", "", 15928, 1378994, 9, 1, 533},
	[1117] = {"3856", "Noth the Plaguebringer", "", 16590, 1379004, 9, 1, 533},
	[1112] = {"3857", "Heigan the Unclean", "", 16309, 1378984, 9, 1, 533},
	[1115] = {"3858", "Loatheb", "", 16110, 1378991, 9, 1, 533},
	[1113] = {"3860", "Instructor Razuvious", "", 16582, 1378988, 9, 1, 533},
	[1109] = {"3861", "Gothik the Harvester", "", 16279, 1378979, 9, 1, 533},
	[1121] = {"3863", "Baron Rivendare", "", 10729, 1385732, 9, 1, 533},
	[1118] = {"3866", "Patchwerk", "", 16174, 1379005, 9, 1, 533},
	[1111] = {"3867", "Grobbulus", "", 16035, 1378981, 9, 1, 533},
	[1108] = {"3868", "Gluth", "", 16064, 1378977, 9, 1, 533},
	[1120] = {"3869", "Thaddius", "", 16137, 1379019, 64, 1, 533},
	[1119] = {"3870", "Sapphiron", "", 16033, 1379010, 9, 1, 533},
	[1114] = {"3871", "Kel'Thuzad", "", 15945, 1378989, 9, 1, 533},
	
	--Kara.
	--Servants quarters has no encounter, not real bosses.
	[652] = {"3780", "Attumen the Huntsman", "", 16416, 1378965, 9, 2, 532},
	[653] = {"3781", "Moroes", "", 16540, 1378999, 9, 2, 532},
	[654] = {"3782", "Maiden of Virtue", "", 16198, 1378997, 67, 2, 532},
	[655] = {"3783", "The Big Bad Wolf", "", 17053, 1385758, 9, 2, 532},
	[656] = {"3787", "The Curator", "", 16958, 1379020, 9, 2, 532},
	[658] = {"3789", "Shade of Aran", "", 16621, 1379012, 9, 2, 532},
	[657] = {"3790", "Terestian Illhoof", "", 11343, 1379017, 9, 2, 532},
	[659] = {"3791", "Netherspite", "", 15363, 1379002, 9, 2, 532},
	[660] = {"3792", "Echo of Medivh", "", 18720, 1385725, 9, 2, 532},
	[661] = {"3793", "Prince Malchezaar", "", 19274, 1379006, 9, 2, 532},
	--[662] = {"", "NightBane", "", 0, 0, 0, 2, 532},
	--Gruul's lair.
	[649] = {"3794", "High King Maulgar", "", 18649, 1378985, 9, 2, 565},
	[650] = {"3799", "Gruul the Dragonkiller", "", 18698, 1378982, 9, 2, 565},
	--Magtheridon's lair.
	[651] = {"3801", "Magtheridon", "", 18527, 1378996, 9, 2, 544},
	--SSC.
	[623] = {"3802", "Hydross the Unstable", "", 20162, 1385741, 9, 2, 548},
	[624] = {"3803", "The Lurker Below", "", 20216, 1385768, 88, 2, 548},
	[625] = {"3805", "Leotheras the Blind", "", 20514, 1385751, 9},
	[626] = {"3809", "Fathom-Lord Karathress", "", 20662, 1385729, 9},
	[627] = {"3810", "Morogrim Tidewalker", "", 20739, 1385756, 9, 2, 548},
	[628] = {"3811", "Lady Vashj", "", 20748, 1385750, 9, 2, 548},
	--The eye.
	[730] = {"3812", "Al'ar", "", 18945, 1385712, 9, 2, 550},
	[731] = {"3813", "Void Reaver", "", 18951, 1385772, 9, 2, 550},
	[732] = {"3814", "High Astromancer Solarian", "", 18239, 1385739, 9, 2, 550},
	[733] = {"3818", "Kael'thas Sunstrider", "", 20023, 607669, 9, 2, 550},
	--Hyjal.
	[618] = {"3820", "Rage Winterchill", "", 17444, 1385762, 9, 2, 534},
	[619] = {"3821", "Anetheron", "", 21069, 1385714, 9, 2, 534},
	[620] = {"3822", "Kaz'rogal", "", 17886, 1385745, 9, 2, 534},
	[621] = {"3823", "Azgalor", "", 18526, 1385719, 9, 2, 534},
	[622] = {"3824", "Archimonde", "", 20939, 1385716, 9, 2, 534},
	--Black temple.
	[601] = {"3825", "High Warlord Naj'entus", "", 21174, 1378986, 9, 2, 564},
	[602] = {"3826", "Supremus", "", 21145, 1379016, 9, 2, 564},
	[603] = {"3827", "Shade of Akama", "", 21357, 1379011, 9, 2, 564},
	[604] = {"3848", "Teron Gorefiend", "", 21262, 1379018, 9, 2, 564},
	[605] = {"3829", "Gurtogg Bloodboil", "", 21443, 1378983, 9, 2, 564},
	[606] = {"3832", "Essence of Suffering", "", 21483, 1385764, 9, 2, 564},
	[607] = {"3833", "Mother Shahraz", "", 21252, 1379000, 9, 2, 564},
	[608] = {"3834", "Gathios the Shatterer", "", 21416, 1385743, 9, 2, 564},
	[609] = {"3838", "Illidan Stormrage", "", 21135, 1378987, 9, 2, 564},
	--Sunwell.
	[724] = {"3839", "Kalecgos", "", 23345, 1385744, 9, 2, 580},
	[725] = {"3841", "Brutallus", "", 22711, 1385722, 9, 2, 580},
	[726] = {"3842", "Felmyst", "", 22838, 1385730, 9, 2, 580},
	[727] = {"3844", "Grand Warlock Alythess", "", 23334, 1390438, 9, 2, 580},
	[728] = {"3845", "M'uru", "", 23404, 1385757, 9, 2, 580},
	[729] = {"3847", "Kil'jaeden", "", 23200, 1385746, 89, 2, 580},
	--Zul'aman (These encounterIDs may need updating they seem too high, they could be different in tbc than retail).
	[1189] = {"618", "Akil'zon", "", 21630, 522190, 9, 2, 568},
	[1190] = {"619", "Nalorakk", "", 21631, 522254, 9, 2, 568},
	[1191] = {"620", "Jan'alai", "", 21633, 522242, 9, 2, 568},
	[1192] = {"621", "Halazzi", "", 21632, 522231, 9, 2, 568},
	[1193] = {"622", "Hex Lord Malacrass", "", 22332, 522235, 9, 2, 568},
	[1194] = {"623", "Daakara", "", 38118, 522217, 9, 2, 568},
};

--Data from EJ_GetInstanceByIndex, some modifications and mapped to instanceID.
--name, description, bgImage, loreImage, buttonImage1, buttonImage2, dungeonAreaMapID.
NRC.instanceTextures = {
	--Classic dungs.
	[227] = {"Blackfathom Deeps", "Once dedicated to the night elves' goddess Elune, Blackfathom Deeps was thought to have been destroyed during the Sundering, lost beneath the ocean. Millennia later, members of the Twilight's Hammer cult were drawn to the temple by whispers and foul dreams. After sacrificing untold numbers of innocents, the cult was rewarded with a new task: to protect one of the Old Gods' most cherished creatures, a pet that is still in need of nurturing before he can unleash his dark powers on the world.", 608156, 608234, 608195, 136325, 221},
	[228] = {"Blackrock Depths", "The smoldering Blackrock Depths are home to the Dark Iron dwarves and their emperor, Dagran Thaurissan. Like his predecessors, he serves under the iron rule of Ragnaros the Firelord, a merciless being summoned into the world centuries ago. The presence of chaotic elementals has attracted Twilight's Hammer cultists to the mountain domain. Along with Ragnaros' servants, they have pushed the dwarves toward increasingly destructive ends that could soon spell doom for all of Azeroth.", 608157, 608235, 608196, 136326, 242},
	[63] = {"Deadmines", "It is said the Deadmines' gold deposits once accounted for a third of Stormwind's treasure reserves. Amid the chaos of the First War, the mines were abandoned and later thought to be haunted, leaving them relatively untouched until the Defias Brotherhood--a group of former laborers turned brigands--claimed the labyrinth as a base of operations for its subversive activities against Stormwind.", 522336, 526404, 522352, 136332, 291},
	[230] = {"Dire Maul", "Built thousands of years ago to house the kaldorei's arcane secrets, the formerly great city of Eldre'Thalas now lies in ruin, writhing with warped, twisted forces. Competing covens once fought for control of Dire Maul's corrupted energy, but they have since settled into uneasy truces, choosing to exploit the power within their own territories rather than continue to battle over the entire complex.", 608161, 608239, 608200, 136333, 240},
	[231] = {"Gnomeregan", "Built deep within the mountains of Dun Morogh, the wondrous city of Gnomeregan was a testament to the gnomes' intelligence and industry. But when the capital was invaded by troggs, the gnomish high tinker was betrayed by his advisor Sicco Thermaplugg. As a result, Gnomeregan was irradiated, and most of its inhabitants slain. The surviving gnomes fled, vowing to return someday and retake their home.", 608163, 608241, 608202, 136336, 226},
	[229] = {"Lower Blackrock Spire", "This imposing fortress, carved into the fiery core of Blackrock Mountain, represented the might of the Dark Iron clan for centuries. More recently, the black dragon Nefarian and his spawn seized the keep's upper spire and ignited a brutal war against the dwarves. The draconic armies have since allied with Warchief Rend Blackhand and his false Horde. This combined force lords over the spire, conducting horrific experiments to bolster its ranks while plotting the meddlesome Dark Irons' downfall.", 608158, 608236, 608197, 136327, 252},
	[232] = {"Maraudon", "According to legend, Zaetar, son of Cenarius, and the earth elemental princess Theradras begot the barbaric centaur race. Shortly after the centaur's creation, the ruthless creatures murdered their father. The grief-stricken Theradras is said to have trapped her lover's spirit within Maraudon, corrupting the region. Now, vicious centaur ghosts and twisted elemental minions roam every corner of the sprawling caves.", 608170, 608248, 608209, 136345, 280},
	[389] = {"Ragefire Chasm", "Ragefire Chasm extends deep below the city of Orgrimmar. Barbaric troggs and devious Searing Blade cultists once plagued the volcanic caves, but now a new threat has emerged: dark shaman. Although Warchief Garrosh Hellscream recently called on a number of shaman to use the elements as weapons against the Alliance, the chasm's current inhabitants appear to be renegades. Reports have surfaced that these shadowy figures are amassing a blistering army that could wreak havoc if unleashed upon Orgrimmar.", 608172, 608250, 608211, 136350, 213},
	[233] = {"Razorfen Downs", "Legends state that where the demigod Agamaggan fell, his blood gave rise to great masses of thorny vines. Recently, scouts have reported seeing undead milling about the region, engendering fears that the dreaded Scourge may be moving to conquer Kalimdor.", 608173, 608251, 608212, 136352, 300},
	[234] = {"Razorfen Kraul", "Legends state that where the demigod Agamaggan fell, his blood gave rise to great masses of thorny vines. Many quilboar have taken up residence in the largest cluster of giant thorns, the Razorfen, which they revere as Agamaggan's resting place.", 608174, 608252, 608213, 136353, 301},
	[311] = {"Scarlet Halls", "The Crusade's fiercest warriors, those who have held their ground and fought to defend the monastery throughout these dark times, are rapidly preparing an army within the Scarlet Halls. These soldiers are bound by their hatred of the unliving, and they are willing to sacrifice everything for their order's righteous cause.", 643259, 643265, 643262, 643268, 431},
	[316] = {"Scarlet Monastery", "The Crusade's fanatical leaders direct their followers from the Scarlet Cathedral, at the heart of the monastery grounds. This heavily guarded location functions as the order's headquarters, and some of the most zealous and intolerant crusaders roam the halls of this once-hallowed place.", 608175, 608253, 608214, 136354, 435},
	[246] = {"Scholomance", "Individuals seeking to master the powers of undeath know well of Scholomance, the infamous school of necromancy located in the dark and foreboding crypts beneath Caer Darrow. In recent years, several of the instructors have changed, but the institution remains under the control of Darkmaster Gandling, a particularly sadistic and insidious practitioner of necromantic magic.", 608176, 608254, 608215, 136355, 476},
	[64] = {"Shadowfang Keep", "Looming over Pyrewood Village from the southern bluffs of Silverpine Forest, Shadowfang Keep casts a shadow as dark as its legacy. Sinister forces occupy these ruins, formerly the dwelling of the mad archmage Arugal's worgen. The restless shade of Baron Silverlaine lingers, while Lord Godfrey and his cabal of erstwhile Gilnean noblemen plot against their enemies both living and undead.", 522342, 526410, 522358, 136357, 310},
	[236] = {"Stratholme", "Stratholme was once the jewel of northern Lordaeron, but today it is remembered for its harrowing fall to ruin. It was here that Prince Arthas turned his back on the noble paladin Uther Lightbringer, slaughtering countless residents believed to be infected with the horrific plague of undeath. Ever since, cursed Stratholme has been marred by death, betrayal, and hopelessness.", 608177, 608255, 608216, 136359, 317},
	[238] = {"The Stockade", "Stormwind Stockade is a closely guarded prison built beneath the canals of Stormwind City. Warden Thelwater keeps watch over the stockade and the highly dangerous criminals who call it home. Recently, the inmates revolted, overthrowing their guards and plunging the prison into a state of pandemonium.", 608184, 608262, 608223, 136358, 225},
	[237] = {"The Temple of Atal'hakkar", "Thousands of years ago, the Gurubashi empire was plunged into a civil war by a powerful sect of priests, the Atal'ai, who sought to summon to Azeroth an avatar of their god of blood, Hakkar the Soulflayer. The Gurubashi people exiled the Atal'ai to the Swamp of Sorrows, where the priests built the Temple of Atal'Hakkar. Ysera, Aspect of the green dragonflight, sank the temple beneath the swamp and assigned wardens to ensure that the summoning rituals never be performed again.", 608178, 608256, 608217, 136360, 220},
	[239] = {"Uldaman", "Uldaman is an ancient titan vault buried deep within the earth. It is said the titans sealed away a failed experiment there and then moved on to a new project, related to the genesis of the dwarves. Tales of a fabled treasure containing great knowledge have enticed would-be treasure hunters to dig deeper into the secrets of Uldaman, a task made perilous by the presence of stone defenders, savage troggs, Dark Iron invaders, and other dangers lurking in the lost city.", 608186, 608264, 608225, 136363, 230},
	[240] = {"Wailing Caverns", "Years ago, the famed druid Naralex and his followers descended into the shadowy Wailing Caverns, named for the mournful cry one hears when steam bursts from the cave system's fissures. Naralex planned to use the underground springs to restore lushness to the arid Barrens. But upon entering the Emerald Dream, he saw his vision of regrowth turn into a waking nightmare, one that has plagued the caverns ever since.", 608190, 608313, 608229, 136364, 279},
	[241] = {"Zul'Farrak", "Zul'Farrak was once the shining jewel of Tanaris, ferociously protected by the cunning Sandfury tribe. Despite the trolls' tenacity, this isolated group was forced to surrender much of its territory throughout history. Now, it appears that Zul'Farrak's inhabitants are creating a horrific army of undead trolls to conquer the surrounding region. Other disturbing rumors tell of an ancient creature sleeping within the city--one that, if awakened, will rain death and destruction across Tanaris.", 608191, 608267, 608230, 136368, 219},
	--Classic raids.
	[7249] = {"Onyxia's Lair", "", 1396463, 1396508, 1396589, 329121, 0},
	[409] = {"Molten Core", "", 1396460, 1396505, 1396586, 136346, 0, 1},
	[469] = {"Blackwing Lair", "", 1396454, 1396499, 1396580, 136329, 0, 2},
	[309] = {"Zul'Gurub", "Zul'Gurub was the capital of the Gurubashi jungle trolls, a tribe that once controlled the vast jungles of the south. It was here that Jin'do the Hexxer summoned the savage loa Hakkar the Soulflayer into Azeroth. Of late, these efforts have begun anew amid an alliance between the Gurubashi and Zandalar trolls that seeks to establish a unified troll empire.", 522348, 526416, 522364, 136369, 337, 3},
	[509] = {"Ruins of Ahn'Qiraj", "", 1396465, 1396510, 1396591, 136320, 0, 4},
	[531] = {"Temple of Ahn'Qiraj", "", 1396467, 1396512, 1396593, 136321, 0, 5},
	[533] = {"Naxxramas", "", 1396461, 1396506, 1396587, 136347, 0, 6},
	--TBC dungs.
	[558] = {"Auchenai Crypts", "The original exiles on Draenor found death to be an unsettling and unfortunate consequence of life, and so the draenei hid their dead away in the subterranean grave-city of Auchindoun, a labyrinthine marvel located beneath the forests of Terokkar.", 608154, 608232, 608193, 136323, 0},
	[543] = {"Hellfire Ramparts", "At the heart of Outland's barren Hellfire Peninsula stands Hellfire Citadel, a nearly impenetrable bastion that served as the Horde's base of operations throughout the First and Second Wars.", 608168, 608246, 608207, 136338, 0},
	[585] = {"Magisters' Terrace", "After his defeat in Tempest Keep, Kael'thas Sunstrider publicly revealed his alliance with the ruthless Burning Legion. Intent upon summoning the demon lord Kil'jaeden, Kael'thas has returned to the Isle of Quel'Danas to make the final preparations for his master's arrival.", 608169, 608247, 608208, 136344, 0},
	[557] = {"Mana-Tombs", "The original exiles on Draenor found death to be an unsettling and unfortunate consequence of life, and so the draenei hid their dead away in the subterranean grave-city of Auchindoun, a labyrinthine marvel located beneath the forests of Terokkar.", 608154, 608232, 608193, 136323, 0},
	[560] = {"Old Hillsbrad Foothills", "Deep within the Caverns of Time, the brooding dragon Nozdormu has awakened. Since the world was young, the bronze dragonflight has safeguarded the winding labyrinth, monitoring the shifting timeways to ensure that the delicate balance of time is upheld.", 608159, 608237, 608198, 136330, 0},
	[556] = {"Sethekk Halls", "The original exiles on Draenor found death to be an unsettling and unfortunate consequence of life, and so the draenei hid their dead away in the subterranean grave-city of Auchindoun, a labyrinthine marvel located beneath the forests of Terokkar.", 608154, 608232, 608193, 136323, 0},
	[555] = {"Shadow Labyrinth", "The original exiles on Draenor found death to be an unsettling and unfortunate consequence of life, and so the draenei hid their dead away in the subterranean grave-city of Auchindoun, a labyrinthine marvel located beneath the forests of Terokkar.", 608154, 608232, 608193, 136323, 0},
	[552] = {"The Arcatraz", "The mighty Tempest Keep was created by the enigmatic naaru: sentient beings of pure energy and the sworn enemies of the Burning Legion. In addition to serving as a base of operations for the naaru, the structure itself possesses the technology to teleport through alternate dimensions, traveling from one location to another in the blink of an eye.", 608179, 608257, 608218, 136362, 0},
	[269] = {"The Black Morass", "Deep within the Caverns of Time, the brooding dragon Nozdormu has awakened. Since the world was young, the bronze dragonflight has safeguarded the winding labyrinth, monitoring the shifting timeways to ensure that the delicate balance of time is upheld.", 608159, 608237, 608198, 136330, 0},
	[542] = {"The Blood Furnace", "At the heart of Outland's barren Hellfire Peninsula stands Hellfire Citadel, a nearly impenetrable bastion that served as the Horde's base of operations throughout the First and Second Wars.", 608168, 608246, 608207, 136338, 0},
	[553] = {"The Botanica", "The mighty Tempest Keep was created by the enigmatic naaru: sentient beings of pure energy and the sworn enemies of the Burning Legion. In addition to serving as a base of operations for the naaru, the structure itself possesses the technology to teleport through alternate dimensions, traveling from one location to another in the blink of an eye.", 608179, 608257, 608218, 136362, 0},
	[554] = {"The Mechanar", "The mighty Tempest Keep was created by the enigmatic naaru: sentient beings of pure energy and the sworn enemies of the Burning Legion. In addition to serving as a base of operations for the naaru, the structure itself possesses the technology to teleport through alternate dimensions, traveling from one location to another in the blink of an eye.", 608179, 608257, 608218, 136362, 0},
	[540] = {"The Shattered Halls", "At the heart of Outland's barren Hellfire Peninsula stands Hellfire Citadel, a nearly impenetrable bastion that served as the Horde's base of operations throughout the First and Second Wars.", 608168, 608246, 608207, 136338, 0},
	[547] = {"The Slave Pens", "Coilfang Reservoir is the name for a naga-dominated compound that lurks under Zangarmarsh's deepest waters. The reservoir, punctured throughout by massive open pipes and pistons, seems big enough to house armies - and, yet, its purpose isn't strictly military.", 608160, 608238, 608199, 136331, 0},
	[545] = {"The Steamvault", "Coilfang Reservoir is the name for a naga-dominated compound that lurks under Zangarmarsh's deepest waters. The reservoir, punctured throughout by massive open pipes and pistons, seems big enough to house armies - and, yet, its purpose isn't strictly military.", 608160, 608238, 608199, 136331, 0},
	[546] = {"The Underbog", "Coilfang Reservoir is the name for a naga-dominated compound that lurks under Zangarmarsh's deepest waters. The reservoir, punctured throughout by massive open pipes and pistons, seems big enough to house armies - and, yet, its purpose isn't strictly military.", 608160, 608238, 608199, 136331, 0},
	--TBC raids.
	[532] = {"Karazhan", "", 1396458, 1396503, 1396584, 136343, 0, 1},
	[565] = {"Gruul's Lair", "", 1396456, 1396501, 1396582, 136337, 0, 2},
	[544] = {"Magtheridon's Lair", "", 1396459, 1396504, 1396585, 136340, 0, 3},
	[548] = {"Serpentshrine Cavern", "" ,608160, 608238, 608199, 136356, 0, 4},
	[550] = {"The Eye", "", 608179, 608257, 608218, 136362, 0, 5},
	[534] = {"The Battle for Mount Hyjal", "", 608159, 608237, 608198, 136330, 0, 6},
	[564] = {"Black Temple", "", 1396453, 1396498, 1396579, 136328, 0, 7},
	[568] = {"Zul'Aman", "Echoes of unfulfilled vengeance linger in the one-time capital of the Amani tribe, Zul'Aman. Though the Amani trolls answered their warlord's call to arms, Zul'jin was denied his goal of restoring the empire to its former glory. Where he failed, the Zandalar tribe will succeed. Left unchecked, the united tribes will reclaim their lands and savor a merciless retribution.", 522347, 526415, 522363, 136367, 0, 8},
	[580] = {"Sunwell Plateau", "", 1396466, 1396511, 1396592, 136361, 0, 9},
};

--Trash and boss lists taken from wowhead and refined.
NRC.zones = {
	--Classic dungeons.
	[33] = {
		name = L["Shadowfang Keep"],
		type = "dungeon",
		expansion = "classic",
	},
	[48] = {
		name = L["Blackfathom Deeps"],
		type = "dungeon",
		expansion = "classic",
	},
	[230] = {
		name = L["Blackrock Depths"],
		type = "dungeon",
		expansion = "classic",
	},
	[229] = {
		name = L["Blackrock Spire"],
		type = "dungeon",
		expansion = "classic",
	},
	[429] = {
		name = L["Dire Maul"],
		type = "dungeon",
		expansion = "classic",
	},
	[90] = {
		name = L["Gnomeregan"],
		type = "dungeon",
		expansion = "classic",
	},
	[349] = {
		name = L["Maraudon"],
		type = "dungeon",
		expansion = "classic",
	},
	[389] = {
		name = L["Ragefire Chasm"],
		type = "dungeon",
		expansion = "classic",
	},
	[129] = {
		name = L["Razorfen Downs"],
		type = "dungeon",
		expansion = "classic",
	},
	[47] = {
		name = L["Razorfen Kraul"],
		type = "dungeon",
		expansion = "classic",
	},
	[1004] = {
		name = L["Scarlet Monastery"],
		type = "dungeon",
		expansion = "classic",
	},
	[1007] = {
		name = L["Scholomance"],
		type = "dungeon",
		expansion = "classic",
	},
	[329] = {
		name = L["Stratholme"],
		type = "dungeon",
		expansion = "classic",
	},
	[36] = {
		name = L["The Deadmines"],
		type = "dungeon",
		expansion = "classic",
	},
	[34] = {
		name = L["The Stockade"],
		type = "dungeon",
		expansion = "classic",
	},
	[109] = {
		name = L["The Temple of Atal'Hakkar"],
		type = "dungeon",
		expansion = "classic",
	},
	[70] = {
		name = L["Uldaman"],
		type = "dungeon",
		expansion = "classic",
	},
	[43] = {
		name = L["Wailing Caverns"],
		type = "dungeon",
		expansion = "classic",
	},
	[209] = {
		name = L["Zul'Farrak"],
		type = "dungeon",
		expansion = "classic",
	},
	--Classic raids.
	[249] = {
		name = L["Onyxia's Lair"],
		type = "raid",
		expansion = "classic",
		noLockout = true,
	},
	[309] = {
		name = L["Zul'gurub"],
		type = "raid",
		expansion = "classic",
	},
	[409] = {
		name = L["Molten Core"],
		type = "raid",
		expansion = "classic",
		noLockout = true,
	},
	[469] = {
		name = L["Blackwing Lair"],
		type = "raid",
		expansion = "classic",
		noLockout = true,
		maxPlayers = 40,
	},
	[509] = {
		name = L["Ruins of Ahn'Qiraj"],
		type = "raid",
		expansion = "classic",
	},
	[531] = {
		name = L["Temple of Ahn'Qiraj"],
		type = "raid",
		expansion = "classic",
		noLockout = true,
	},
	[533] = {
		name = L["Naxxramas"],
		type = "raid",
		expansion = "classic",
		noLockout = true,
	},
	
	--TBC dungeons.
	[558] = {
		name = L["Auchenai Crypts"],
		type = "dungeon",
		expansion = "tbc",
	},
	[543] = {
		name = L["Hellfire Ramparts"],
		type = "dungeon",
		expansion = "tbc",
	},
	[585] = {
		name = L["Magisters' Terrace"],
		type = "dungeon",
		expansion = "tbc",
	},
	[557] = {
		name = L["Mana-Tombs"],
		type = "dungeon",
		expansion = "tbc",
	},
	[560] = {
		name = L["Old Hillsbrad Foothills"],
		type = "dungeon",
		expansion = "tbc",
	},
	[556] = {
		name = L["Sethekk Halls"],
		type = "dungeon",
		expansion = "tbc",
	},
	[555] = {
		name = L["Shadow Labyrinth"],
		type = "dungeon",
		expansion = "tbc",
	},
	[552] = {
		name = L["The Arcatraz"],
		type = "dungeon",
		expansion = "tbc",
	},
	[269] = { --Is this low ID right?
		name = L["The Black Morass"],
		type = "dungeon",
		expansion = "tbc",
	};
	[542] = {
		name = L["The Blood Furnace"],
		type = "dungeon",
		expansion = "tbc",
	},
	[553] = {
		name = L["The Botanica"],
		type = "dungeon",
		expansion = "tbc",
	};
	[554] = {
		name = L["The Mechanar"],
		type = "dungeon",
		expansion = "tbc",
	},
	[540] = {
		name = L["The Shattered Halls"],
		type = "dungeon",
		expansion = "tbc",
	},
	[547] = {
		name = L["The Slave Pens"],
		type = "dungeon",
		expansion = "tbc",
	},
	[545] = {
		name = L["The Steamvault"],
		type = "dungeon",
		expansion = "tbc",
	},
	[546] = {
		name = L["The Underbog"],
		type = "dungeon",
		expansion = "tbc",
	},
	--TBC raids.
	[532] = {
		name = L["Karazhan"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 11, --Excluding servant quarters miniboss.
		bosses = {
			[16181] = L["Rokad the Ravager"],
			[16180] = L["Shadikith the Glider"],
			[16179] = L["Hyakiss the Lurker"],
			[16152] = L["Attumen the Huntsman"],
			[17535] = L["Dorothee"],
			[17534] = L["Julianne"],
			[16457] = L["Maiden of Virtue"],
			[16151] = L["Midnight"],
			[15687] = L["Moroes"],
			[15689] = L["Netherspite"],
			[17225] = L["Nightbane"],
			[15690] = L["Prince Malchezaar"],
			[17546] = L["Roar"],
			[17533] = L["Romulo"],
			[16524] = L["Shade of Aran"],
			[17543] = L["Strawman"],
			[15688] = L["Terestian Illhoof"],
			[17521] = L["The Big Bad Wolf"],
			[18168] = L["The Crone"],
			[15691] = L["The Curator"],
			[17547] = L["Tinhead"],
			[17548] = L["Tito"],
		},
		trash = {
			[16488] = L["Arcane Anomaly"],
			[16504] = L["Arcane Protector"],
			[16485] = L["Arcane Watchman"],
			--[19783] = L["Astral Flare"],
			--[17283] = L["Astral Spark"],
			--[16812] = L["Barnes"],
			[19874] = L["Baron Rafe Dreuger"],
			[19875] = L["Baroness Dorothea Millstipe"],
			--[16426] = L["Bennett"],
			--[16153] = L["Berthold"],
			--[16159] = L["Calliard"],
			[16489] = L["Chaotic Sentience"],
			[16170] = L["Coldmist Stalker"],
			[16171] = L["Coldmist Widow"],
			[16461] = L["Concubine"],
			--[17167] = L["Conjured Elemental"],
			--[21160] = L["Conjured Water Elemental"],
			--[17248] = L["Demon Chains"],
			[16177] = L["Dreadbeast"],
			--[16806] = L["Ebonlocke"],
			--[16816] = L["Echo of Medivh"],
			[16545] = L["Ethereal Spellfilcher"],
			[16544] = L["Ethereal Thief"],
			--[17252] = L["Felguard"],
			--[17267] = L["Fiendish Imp"],
			[16595] = L["Fleshbeast"],
			[16481] = L["Ghastly Haunt"],
			[16412] = L["Ghostly Baker"],
			[16470] = L["Ghostly Philanthropist"],
			[16414] = L["Ghostly Steward"],
			--[16814] = L["Gradav"],
			--[17603] = L["Grandmother"],
			[16596] = L["Greater Fleshbeast"],
			[16174] = L["Greater Shadowbat"],
			--[16169] = L["Hastings"],
			[16539] = L["Homunculus"],
			--[21664] = L["Human Charger"],
			--[21682] = L["Human Cleric"],
			--[21683] = L["Human Conjurer"],
			--[17211] = L["Human Footman"],
			[16179] = L["Hyakiss the Lurker"],
			--[17651] = L["Image of Medivh"],
			[16815] = L["Kamsis"],
			[17229] = L["Kil'rek"],
			--[21684] = L["King Llane"],
			--[16388] = L["Koren"],
			[19872] = L["Lady Catriona Von'Indi"],
			[17007] = L["Lady Keira Berrybuck"],
			[19873] = L["Lord Crispin Ference"],
			[19876] = L["Lord Robin Daris"],
			[16529] = L["Magical Horror"],
			[16491] = L["Mana Feeder"],
			[16530] = L["Mana Warp"],
			[16460] = L["Night Mistress"],
			--[17469] = L["Orc Grunt"],
			--[21747] = L["Orc Necrolyte"],
			--[21750] = L["Orc Warlock"],
			--[21748] = L["Orc Wolf"],
			[16406] = L["Phantom Attendant"],
			[16425] = L["Phantom Guardsman"],
			[16409] = L["Phantom Guest"],
			[17067] = L["Phantom Hound"],
			[16472] = L["Phantom Stagehand"],
			[16408] = L["Phantom Valet"],
			[16178] = L["Phase Hound"],
			[17261] = L["Restless Skeleton"],	
			--[16811] = L["Sebastian"],		
			[16540] = L["Shadow Pillager"],
			[16173] = L["Shadowbat"],
			[16176] = L["Shadowbeast"],
			[16471] = L["Skeletal Usher"],
			[16415] = L["Skeletal Waiter"],
			[16526] = L["Sorcerous Shade"],
			[16389] = L["Spectral Apprentice"],
			[15547] = L["Spectral Charger"],
			[16411] = L["Spectral Chef"],
			[16468] = L["Spectral Patron"],
			[16473] = L["Spectral Performer"],
			[16410] = L["Spectral Retainer"],
			[16424] = L["Spectral Sentry"],
			[16407] = L["Spectral Servant"],
			[15551] = L["Spectral Stable Hand"],
			[15548] = L["Spectral Stallion"],
			[16525] = L["Spell Shade"],
			[14881] = L["Spider"],	
			--[21726] = L["Summoned Daemon"],
			[16492] = L["Syphoner"],
			[16482] = L["Trapped Soul"],
			[16175] = L["Vampiric Shadowbat"],
			[16459] = L["Wanton Hostess"],
			--[21752] = L["Warchief Blackhand"],
			--[16813] = L["Wravien"],
			--[17518] = L["Ythyar"],
		},
	},
	[565] = {
		name = L["Gruul's Lair"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 2,
		bosses = {
			[18836] = L["Blindeye the Seer"],
			[19044] = L["Gruul the Dragonkiller"],
			[18831] = L["High King Maulgar"],
			[18835] = L["Kiggler the Crazed"],
			[18832] = L["Krosh Firehand"],
			[18834] = L["Olm the Summoner"],
		},
		trash = {
			[21350] = L["Gronn-Priest"],
			[19389] = L["Lair Brute"],
			--[18847] = L["Wild Fel Stalker"],
		},
	},
	[544] = {
		name = L["Magtheridon's Lair"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 1,
		bosses = {
			[17257] = L["Magtheridon"],
		},
		trash = {
			--[17454] = L["Burning Abyssal"],
			--[17256] = L["Hellfire Channeler"],
			[18829] = L["Hellfire Warder"],
		},
	},
	[548] = {
		name = L["Serpentshrine Cavern"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		startType = "boss",
		bossCount = 6,
		bosses = {
			[21216] = L["Hydross the Unstable"],
			[21217] = L["The Lurker Below"],
			[21215] = L["Leotheras the Blind"],
			[21214] = L["Fathom-Lord Karathress"],
			[21213] = L["Morogrim Tidewalker"],
			[21212] = L["Lady Vashj"],
		},
		trash = {
			[21865] = L["Coilfang Ambusher"],
			[21221] = L["Coilfang Beast-Tamer"],
			[22055] = L["Coilfang Elite"],
			[21299] = L["Coilfang Fathom-Witch"],
			[21508] = L["Coilfang Frenzy"],
			[21873] = L["Coilfang Guardian"],
			[21339] = L["Coilfang Hate-Screamer"],
			[21220] = L["Coilfang Priestess"],
			[21298] = L["Coilfang Serpentguard"],
			[21301] = L["Coilfang Shatterer"],
			[22056] = L["Coilfang Strider"],
			[22347] = L["Colossus Lurker"],
			[22352] = L["Colossus Rager"],
			--[21958] = L["Enchanted Elemental"],
			--[22119] = L["Fathom Lurker"], --Fathom-Lord Karathress pet.
			--[22120] = L["Fathom Sporebat"], --Fathom-Lord Karathress pet.
			--[21964] = L["Fathom-Guard Caribdis"],
			--[21966] = L["Fathom-Guard Sharkkis"],
			--[21965] = L["Fathom-Guard Tidalvess"],
			[21230] = L["Greyheart Nether-Mage"],
			[21231] = L["Greyheart Shield-Bearer"],
			[21232] = L["Greyheart Skulker"],
			[21806] = L["Greyheart Spellbinder"],
			[21263] = L["Greyheart Technician"],
			[21229] = L["Greyheart Tidecaller"],
			--[21857] = L["Inner Demon"],
			--[22035] = L["Pure Spawn of Hydross"],
			--[22250] = L["Rancid Mushroom"],
			--[22820] = L["Seer Olum"],
			[21863] = L["Serpentshrine Lurker"],
			[21246] = L["Serpentshrine Sporebat"],
			[22238] = L["Serpentshrine Tidecaller"],
			--[21875] = L["Shadow of Leotheras"],
			--[22009] = L["Tainted Elemental"],
			--[22036] = L["Tainted Spawn of Hydross"],
			--[21253] = L["Tainted Water Elemental"],
			[21224] = L["Tidewalker Depth-Seer"],
			[21227] = L["Tidewalker Harpooner"],
			[21228] = L["Tidewalker Hydromancer"],
			[21920] = L["Tidewalker Lurker"],
			[21226] = L["Tidewalker Shaman"],
			[21225] = L["Tidewalker Warrior"],
			[21251] = L["Underbog Colossus"],
			[21218] = L["Vashj'ir Honor Guard"],
		},
	},
	[550] = {
		name = L["Tempest Keep"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 4,
		bosses = {
			[19514] = "Al'ar",
			[19516] = "Void Reaver",
			[18805] = "High Astromancer Solarian",
			[19622] = "Kael'thas Sunstrider",
		},
		trash = {
			[20043] = "Apprentice Star Scryer",
			[20033] = "Astromancer",
			[20046] = "Astromancer Lord",
			[20031] = "Bloodwarder Legionnaire",
			[20035] = "Bloodwarder Marshal",
			[20036] = "Bloodwarder Squire",
			[20032] = "Bloodwarder Vindicator",
			--[21270] = "Cosmic Infuser",
			[20047] = "Crimson Hand Battle Mage",
			[20049] = "Crimson Hand Blood Knight",
			[20048] = "Crimson Hand Centurion",
			[20050] = "Crimson Hand Inquisitor",
			[20040] = "Crystalcore Devastator",
			[20052] = "Crystalcore Mechanic",
			[20041] = "Crystalcore Sentinel",
			--[21269] = "Devastation",
			--[19551] = "Ember of Al'ar",
			--[20062] = "Grand Astromancer Capernian",
			--[21271] = "Infinity Blades",
			--[20060] = "Lord Sanguinar",
			--[20063] = "Master Engineer Telonicus",
			[20045] = "Nether Scryer",
			[21268] = "Netherstrand Longbow",
			[20044] = "Novice Astromancer",
			[21273] = "Phaseshift Bulwark",
			--[21362] = "Phoenix",
			--[21364] = "Phoenix Egg",
			[20039] = "Phoenix-Hawk",
			[20038] = "Phoenix-Hawk Hatchling",
			[18925] = "Solarium Agent",
			[18806] = "Solarium Priest",
			--[21274] = "Staff of Disintegration",
			[20034] = "Star Scryer",
			[20037] = "Tempest Falconer",
			[20042] = "Tempest-Smith",
			--[20064] = "Thaladred the Darkener",
			--[21272] = "Warp Slicer",
		},
	},
	[534] = {
		name = L["Hyjal Summit"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 5,
		bosses = {
			[17767] = "Rage Winterchill",
			[17808] = "Anetheron",
			[17888] = "Kaz'rogal",
			[17842] = "Azgalor",
			[17968] = "Archimonde",
		},
		trash = {
			[17864] = "Lesser Doomguard",
			[17895] = "Ghoul",
			[17897] = "Crypt Fiend",
			[17898] = "Abomination",
			[17899] = "Shadowy Necromancer",
			[17902] = "Skeleton Invader",
			[17903] = "Skeleton Mage",
			[17905] = "Banshee",
			[17906] = "Gargoyle",
			[17907] = "Frost Wyrm",
			[17908] = "Giant Infernal",
			[17916] = "Fel Stalker",
		},
	},
	[564] = {
		name = L["Black Temple"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 9,
		bosses = {
			[23418] = L["Essence of Suffering"],
			[22948] = L["Gurtogg Bloodboil"],
			[22887] = L["High Warlord Naj'entus"],
			[22917] = L["Illidan Stormrage"],
			[22947] = L["Mother Shahraz"],
			[22841] = L["Shade of Akama"],
			[22898] = L["Supremus"],
			[22871] = L["Teron Gorefiend"],
			[23426] = L["The Illidari Council"], --Is this an actual npc?
			--Council bosses.
			[22949] = L["Gathios the Shatterer"],
			[22950] = L["High Nethermancer Zerevor"],
			[22951] = L["Lady Malande"],
			[22952] = L["Veras Darkshadow"],
		},
		trash = {
			[22844] = "Ashtongue Battlelord",
			[22845] = "Ashtongue Mystic",
			[22846] = "Ashtongue Stormcaller",
			[22847] = "Ashtongue Primalist",
			[22848] = "Storm Fury",
			[22849] = "Ashtongue Feral Spirit",
			[22853] = "Illidari Defiler",
			[22855] = "Illidari Nightlord",
			[22869] = "Illidari Boneslicer",
			[22873] = "Coilskar General",
			[22874] = "Coilskar Harpooner",
			[22875] = "Coilskar Sea-Caller",
			[22876] = "Coilskar Soothsayer",
			[22877] = "Coilskar Wrangler",
			[22878] = "Aqueous Lord",
			[22879] = "Shadowmoon Reaver",
			[22880] = "Shadowmoon Champion",
			[22881] = "Aqueous Surger",
			[22882] = "Shadowmoon Deathshaper",
			[22883] = "Aqueous Spawn",
			[22884] = "Leviathan",
			[22885] = "Dragon Turtle",
			[22929] = "Greater Shadowfiend",
			[22939] = "Temple Acolyte",
			[22945] = "Shadowmoon Blood Mage",
			[22946] = "Shadowmoon War Hound",
			[22953] = "Wrathbone Flayer",
			[22954] = "Illidari Fearbringer",
			[22955] = "Charming Patron",
			[22956] = "Priestess of Torment",
			[22957] = "Mistress of Dementia",
			[22959] = "Ardent Host",
			[22960] = "Dragonmaw Wyrmcaller",
			[22962] = "Mistress of Woe",
			[22963] = "Bonechewer Worker",
			[22964] = "Priestess of Delight",
			[22965] = "Devoted Steward",
			[23018] = "Shadowmoon Houndmaster",
			[23028] = "Bonechewer Taskmaster",
			[23030] = "Dragonmaw Sky Stalker",
			[23047] = "Shadowmoon Soldier",
			[23049] = "Shadowmoon Weapon Master",
			[23083] = "Shadowmoon Riding Hound",
			[23111] = "Shadowy Construct",
			[23147] = "Shadowmoon Grunt",
			[23172] = "Hand of Gorefiend",
			[23196] = "Bonechewer Behemoth",
			[23215] = "Ashtongue Sorcerer",
			[23216] = "Ashtongue Defender",
			[23222] = "Bonechewer Brawler",
			[23223] = "Bonechewer Spectator",
			[23232] = "Mutant War Hound",
			[23235] = "Bonechewer Blade Fury",
			[23236] = "Bonechewer Shield Disciple",
			[23237] = "Bonechewer Blood Prophet",
			[23239] = "Bonechewer Combatant",
			[23318] = "Ashtongue Rogue",
			[23319] = "Ashtongue Broken",
			[23330] = "Dragonmaw Wind Reaver",
			[23337] = "Illidari Centurion",
			[23339] = "Illidari Heartseeker",
			[23371] = "Shadowmoon Fallen",
			[23374] = "Ashtongue Stalker",
			[23389] = "Fallen Ally",
			[23394] = "Promenade Sentinel",
			[23397] = "Illidari Blood Lord",
			[23398] = "Angered Soul Fragment",
			[23399] = "Suffering Soul Fragment",
			[23400] = "Illidari Archon",
			[23401] = "Hungering Soul Fragment",
			[23402] = "Illidari Battle-mage",
			[23403] = "Illidari Assassin",
			[23421] = "Ashtongue Channeler",
			[23436] = "Image of Dementia",
			[23469] = "Enslaved Soul",
			[23523] = "Ashtongue Elementalist",
			[23524] = "Ashtongue Spiritbinder",
		},
	},
	[568] = {
		name = L["Zul'Aman"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 6,
		bosses = {
			[23574] = L["Akil'zon <Eagle Avatar>"],
			[23576] = L["Nalorakk <Bear Avatar>"],
			[23578] = L["Jan'alai <Dragonhawk Avatar>"],
			[23577] = L["Halazzi <Lynx Avatar>"],
			[24239] = L["Hex Lord Malacrass"],
			[23863] = L["Zul'jin"],
		},
		trash = {
			[23542] = "Amani'shi Axe Thrower",
			[23580] = "Amani'shi Warbringer",
			[23581] = "Amani'shi Medicine Man",
			[23582] = "Amani'shi Tribesman",
			[23584] = "Amani Bear",
			[23586] = "Amani'shi Scout",
			[23587] = "Amani'shi Reinforcement",
			[23596] = "Amani'shi Flame Caster",
			[23597] = "Amani'shi Guardian",
			[23598] = "Amani Dragonhawk Hatchling",
			[23757] = "Amani Healing Ward",
			[23774] = "Amani'shi Trainer",
			[23818] = "Amani'shi Hatcher",
			[23822] = "Amani Protective Ward",
			[23834] = "Amani Dragonhawk",
			[23889] = "Amani'shi Savage",
			[24043] = "Amani Lynx",
			[24047] = "Amani Crocolisk",
			[24059] = "Amani'shi Beast Tamer",
			[24064] = "Amani Lynx Cub",
			[24065] = "Amani'shi Handler",
			[24138] = "Tamed Amani Crocolisk",
			[24159] = "Amani Eagle",
			[24175] = "Amani'shi Lookout",
			[24179] = "Amani'shi Wind Walker",
			[24180] = "Amani'shi Protector",
			[24217] = "Amani Bear Mount",
			[24225] = "Amani'shi Warrior",
			[24240] = "Alyson Antille",
			[24241] = "Thurg",
			[24242] = "Slither",
			[24243] = "Lord Raadan",
			[24244] = "Gazakroth",
			[24245] = "Fenstalker",
			[24246] = "Darkheart",
			[24247] = "Koragg",
			[24338] = "Amani Snake",
			[24374] = "Amani'shi Berserker",
			[24504] = "Amani'shi Hatcher",
			[24530] = "Amani Elder Lynx",
			[24549] = "Amani'shi Tempest",
			[24858] = "Soaring Eagle",
		},
	},
	[580] = {
		name = L["Sunwell Plateau"],
		type = "raid",
		expansion = "tbc",
		noLockout = true,
		bossCount = 6,
		bosses = {
			[24850] = L["Kalecgos"],
			[24892] = L["Sathrovarr the Corruptor"],
			[24882] = L["Brutallus"],
			[25038] = L["Felmyst"],
			[25166] = L["Grand Warlock Alythess"],
			[25165] = L["Lady Sacrolash"],
			[25741] = L["M'uru"],
			[25840] = L["Entropiu"],
			[25315] = L["Kil'jaeden"],
		},
		trash = {
			--[25268] = "Unyielding Dead", --Skeletons during Felmyst.
			[25363] = "Sunblade Cabalist",
			[25367] = "Sunblade Arch Mage",
			[25368] = "Sunblade Slayer",
			[25369] = "Sunblade Vindicator",
			[25370] = "Sunblade Dusk Priest",
			[25371] = "Sunblade Dawn Priest",
			[25372] = "Sunblade Scout",
			[25373] = "Shadowsword Soulbinder",
			[25483] = "Shadowsword Manafiend",
			[25484] = "Shadowsword Assassin",
			[25485] = "Shadowsword Deathbringer",
			[25486] = "Shadowsword Vanquisher",
			--[25502] = "Shield Orb", --Floating orbs during KJ.
			[25506] = "Shadowsword Lifeshaper",
			[25507] = "Sunblade Protector",
			[25508] = "Shadowsword Guardian",
			[25509] = "Priestess of Torment",
			--[25588] = "Hand of the Deceiver", --KJ adds.
			[25593] = "Apocalypse Guard",
			[25597] = "Oblivion Mage",
			[25598] = "Volatile Felfire Fiend",
			[25599] = "Cataclysm Hound",
			--[25708] = "Sinister Reflection", --KJ adds.
			--[25772] = "Void Sentinel", --Muru adds.
			[25798] = "Shadowsword Berserker",
			[25799] = "Shadowsword Fury Mage",
			[25837] = "Shadowsword Commander",
			[25851] = "Volatile Fiend",
			[25867] = "Sunblade Dragonhawk",
			[25948] = "Doomfire Shard",
			[26101] = "Fire Fiend",
		},
	},
}

NRC.flasks = {
	--Classic flasks.
	[17628] = {
		name = "Flask of Supreme Power",
		icon = 134821,
		desc = "+70 Spell Power",
	},
	[17626] = {
		name = "Flask of the Titans",
		icon = 134842,
		desc = "+400 HP",
	},
	[17627] = {
		name = "Flask of Distilled Wisdom",
		icon = 134877,
		desc = "+65 Int",
		maxRank = true,
	},
	[17629] = {
		name = "Flask of Chromatic Resistance",
		icon = 134828,
		desc = "+25 All Resistances",
	},
	--TBC flasks.
	[28518] = {
		name = "Flask of Fortification",
		icon = 134742,
		desc = "+500 HP",
		maxRank = true,
	},
	[28540] = {
		name = "Flask of Pure Death",
		icon = 134738,
		desc = "+80 Shadow/Fire/Frost Spell Power",
		maxRank = true,
	},
	[28520] = {
		name = "Flask of Relentless Assault",
		icon = 134740,
		desc = "+120 Attack Power",
		maxRank = true,
	},
	[28521] = {
		name = "Flask of Blinding Light",
		icon = 134739,
		desc = "+80 Arcane/Holy/Natural Spell Power",
		maxRank = true,
	},
	[28519] = {
		name = "Flask of Mighty Restoration",
		icon = 134741,
		desc = "+25 MP5",
		maxRank = true,
	},
	[42735] = {
		name = "Flask of Chromatic Wonder",
		icon = 134828,
		desc = "+35 All Resistances, +18 Stats",
		maxRank = true,
	},
	--Shat flasks have 2 or 3 spells the same, have to test one day which is correct for each.
	[41607] = {
		name = "Fortification of Shattrath",
		icon = 134742,
		maxRank = true,
	},
	[41609] = {
		name = "Fortification of Shattrath",
		icon = 134742,
		maxRank = true,
	},
	[46837] = {
		name = "Pure Death of Shattrath",
		icon = 134738,
		maxRank = true,
	},
	[46838] = {
		name = "Pure Death of Shattrath",
		icon = 134738,
		maxRank = true,
	},
	[41606] = {
		name = "Relentless Assault of Shattrath",
		icon = 134740,
		maxRank = true,
	},
	[41608] = {
		name = "Relentless Assault of Shattrath",
		icon = 134740,
		maxRank = true,
	},
	[46839] = {
		name = "Blinding Light of Shattrath",
		icon = 134739,
		maxRank = true,
	},
	[46840] = {
		name = "Blinding Light of Shattrath",
		icon = 134739,
		maxRank = true,
	},
	[41605] = {
		name = "Mighty Restoration of Shattrath",
		icon = 134741,
		maxRank = true,
	},
	[41610] = {
		name = "Mighty Restoration of Shattrath",
		icon = 134741,
		maxRank = true,
	},
	[41604] = {
		name = "Supreme Power of Shattrath",
		icon = 134821,
		maxRank = true,
	},
	[41611] = {
		name = "Supreme Power of Shattrath",
		icon = 134821,
		maxRank = true,
	},
	[40572] = {
		name = "Unstable Flask of the Beast",
		icon = 134815,
		maxRank = true,
	},
	[40580] = {
		name = "Unstable Flask of the Beast",
		icon = 134815,
		maxRank = true,
	},
	[40576] = {
		name = "Unstable Flask of the Sorcerer",
		icon = 134822,
		maxRank = true,
	},
	[40588] = {
		name = "Unstable Flask of the Sorcerer",
		icon = 134822,
		maxRank = true,
	},
	[40763] = {
		name = "Unstable Flask of the Sorcerer",
		icon = 134822,
		maxRank = true,
	},
	[40567] = {
		name = "Unstable Flask of the Bandit",
		icon = 134871,
		maxRank = true,
	},
	[40577] = {
		name = "Unstable Flask of the Bandit",
		icon = 134871,
		maxRank = true,
	},
	[40579] = {
		name = "Unstable Flask of the Bandit",
		icon = 134871,
		maxRank = true,
	},
	[40568] = {
		name = "Unstable Flask of the Elder",
		icon = 134857,
		maxRank = true,
	},
	[40582] = {
		name = "Unstable Flask of the Elder",
		icon = 134857,
		maxRank = true,
	},
	[40573] = {
		name = "Unstable Flask of the Physician",
		icon = 134850,
		maxRank = true,
	},
	[40586] = {
		name = "Unstable Flask of the Physician",
		icon = 134850,
		maxRank = true,
	},
	[40575] = {
		name = "Unstable Flask of the Soldier",
		icon = 134864,
		maxRank = true,
	},
	[40587] = {
		name = "Unstable Flask of the Soldier",
		icon = 134864,
		maxRank = true,
	},
};

NRC.battleElixirs = {
	[28503] = {
		name = "Elixir of Major Shadow Power",
		icon = 134771,
		desc = "+55 Shadow Spell Power",
		maxRank = true,
	},
	[38954] = {
		name = "Fel Strength Elixir",
		icon = 134779,
		desc = "+90 Attack Power, -10 Stamina",
		maxRank = true,
	},
	[28497] = {
		name = "Elixir of Major Agility",
		icon = 134751,
		desc = "+35 Agility, +20 Critical Strike Rating",
		maxRank = true,
	},
	[28501] = {
		name = "Elixir of Major Firepower",
		icon = 134772,
		desc = "+55 Fire Spell Power",
		maxRank = true,
	},
	[28493] = {
		name = "Elixir of Major Frost Power",
		icon = 134774,
		desc = "+55 Frost Spell Power",
		maxRank = true,
	},
	[28491] = {
		name = "Elixir of Healing Power",
		icon = 134768,
		desc = "+50 Healing",
		maxRank = true,
	},
	[33726] = {
		name = "Elixir of Mastery",
		icon = 134734,
		desc = "+15 Stats",
		maxRank = true,
	},
	[28490] = {
		name = "Elixir of Major Strength",
		icon = 134773,
		desc = "+35 Strength",
		maxRank = true,
	},
	[33721] = {
		name = "Adept's Elixir",
		icon = 134876,
		desc = "+24 Spell Damage/Healing, +24 Spell Crit",
		maxRank = true,
	},
	[33720] = {
		name = "Onslaught Elixir",
		icon = 134838,
		desc = "+60 Attack Power",
		maxRank = true,
	},
	[17538] = {
		name = "Elixir of the Mongoose",
		icon = 134812,
		desc = "+25 Agility, +28 Crit Rating",
		maxRank = true,
	},
	[11406] = {
		name = "Elixir of Demonslaying",
		icon = 134807,
		desc = "Increases attack power by +265 against demons.",
		maxRank = true,
	},
	[17539] = {
		name = "Greater Arcane Elixir",
		icon = 134805,
		desc = "Increases spell damage by up to 3.",
	},
};

NRC.guardianElixirs = {
	[28514] = {
		name = "Elixir of Empowerment",
		icon = 134761,
		desc = "-30 Target's Magic Resistance", -- Empowerment.
		maxRank = true,
	},
	[28509] = {
		name = "Elixir of Major Mageblood",
		icon = 134778,
		desc = "+16 MP5", --Greater Mana Regeneration.
		maxRank = true,
	},
	[28502] = {
		name = "Elixir of Major Defense",
		icon = 134746,
		desc = "+550 Armor", --Major Armor.
		maxRank = true,
	},
	[39628] = {
		name = "Elixir of Ironskin",
		icon = 134786,
		desc = "+30 Resilience",
		maxRank = true,
	},
	[39627] = {
		name = "Elixir of Draenic Wisdom",
		icon = 134782,
		desc = "+30 Int, +30 Spirit",
		maxRank = true,
	},
	[39626] = {
		name = "Earthen Elixir",
		icon = 134781,
		desc = "-20 Damage Taken",
		maxRank = true,
	},
	[39625] = {
		name = "Elixir of Major Fortitude",
		icon = 134785,
		desc = "+250 HP, +10 HP5",
		maxRank = true,
	},
	[11371] = {
		name = "Gift of Arthas",
		icon = 136157,
		desc = "+10 Shadow Resist, 30% Disease Proc",
		maxRank = true,
	},
	[24382] = {
		name = "Spirit of Zanza",
		icon = 134810,
		desc = "Increases the player's Spirit by 25 and Stamina by 25",
	},
	[24383] = {
		name = "Swiftness of Zanza",
		icon = 134811,
		desc = "Increases the player's run speed by 20%",
	},
};

NRC.foods = {
	[33263] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+23 Spell Power, +20 Spirit",
		maxRank = true,
	},
	[33257] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+30 Stamina, +20 Spirit",
		maxRank = true,
	},
	[33254] = { --Lower stam buff.
		name = "Well Fed",
		icon = 136000,
		desc = "+20 Stamina, +20 Spirit",
	},
	[33259] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+40 Attack Power, +20 Spirit",
		maxRank = true,
	},
	[33261] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+20 Agility, +20 Spirit",
		maxRank = true,
	},
	[33256] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+20 Strength, +20 Spirit",
		maxRank = true,
	},
	[43722] = {
		name = "Enlightened",
		icon = 136000,
		desc = "+20 Spell Crit, +20 Spirit",
		maxRank = true,
	},
	[43764] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+20 Hit Rating, +20 Spirit",
		maxRank = true,
	},
	[33265] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+8 MP5, +20 Stamina",
		maxRank = true,
	},
	[45619] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+8 All Resistances",
		maxRank = true,
	},
	[33268] = {
		name = "Well Fed",
		icon = 136000,
		desc = "+44 Healing, +20 Spirit",
		maxRank = true,
	},
	[43730] = {
		name = "Electrified",
		icon = 135990,
		desc = "Deals Nature Damage to nearby enemies",
		maxRank = true,
	},
};

NRC.scrolls = {
	[12174] = {
		name = "Scroll of Agility IV",
		icon = 135879,
		desc = "+17 Agility",
		order = 1,
		itemID = 10309,
		itemIcon = 134938,
		quality = 1,
	},
	[33077] = {
		name = "Scroll of Agility V",
		icon = 135879,
		desc = "+20 Agility",
		maxRank = true,
		order = 1,
		itemID = 27498,
		itemIcon = 134938,
		quality = 1,
	},
	[12179] = {
		name = "Scroll of Strength IV",
		icon = 136101,
		desc = "+17 Strength",
		order = 2,
		itemID = 10310,
		itemIcon = 134938,
		quality = 1,
	},
	[33082] = {
		name = "Scroll of Strength V",
		icon = 136101,
		desc = "+20 Strength",
		maxRank = true,
		order = 2,
		itemID = 27503,
		itemIcon = 134938,
		quality = 1,
	},
	[12175] = {
		name = "Scroll of Protection IV",
		icon = 132341,
		desc = "+240 Armor",
		order = 3,
		itemID = 10305,
		itemIcon = 134943,
		quality = 1,
	},
	[33079] = {
		name = "Scroll of Protection V",
		icon = 132341,
		desc = "+300 Armor",
		maxRank = true,
		order = 3,
		itemID = 27500,
		itemIcon = 134943,
		quality = 1,
	},
	[12176] = {
		name = "Scroll of Intellect IV",
		icon = 135932,
		desc = "+16 Intellect",
		order = 4,
		itemID = 10308,
		itemIcon = 134937,
		quality = 1,
	},
	[33078] = {
		name = "Scroll of Intellect V",
		icon = 135932,
		desc = "+20 Intellect",
		maxRank = true,
		order = 4,
		itemID = 27499,
		itemIcon = 134937,
		quality = 1,
	},
	[12177] = {
		name = "Scroll of Spirit IV",
		icon = 136126,
		desc = "+15 Spirit",
		order = 5,
		itemID = 10306,
		itemIcon = 134937,
		quality = 1,
	},
	[33080] = {
		name = "Scroll of Spirit V",
		icon = 136126,
		desc = "+30 Spirit",
		maxRank = true,
		order = 5,
		itemID = 27501,
		itemIcon = 134937,
		quality = 1,
	},
	[12178] = {
		name = "Scroll of Stamina IV",
		icon = 136112,
		desc = "+16 Stamina",
		order = 6,
		itemID = 10307,
		itemIcon = 134943,
		quality = 1,
	},
	[33081] = {
		name = "Scroll of Stamina V",
		icon = 136112,
		desc = "+20 Stamina",
		maxRank = true,
		order = 6,
		itemID = 27502,
		itemIcon = 134943,
		quality = 1,
	},
};

--Spell cast IDs not item IDs.
NRC.trackedConsumes = {
	--[[[22734] = { --Debug.
		name = "Drink",
		icon = 132805,
		desc = "Restores 4200 mana over 30 sec. Must remain seated while drinking.",
	},
	[34291] = { --Debug.
		name = "Drink",
		icon = 132805,
		desc = "Restores 5100 mana over 30 sec. Must remain seated while drinking.",
	},
	[25389] = { --Debug.
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "Power infuses the target increasing their Stamina by 79 for 30 min.",
	},]]
	[22792] = {
		name = "Thornling Seed",
		icon = 132877,
		desc = "Plants a Thornling which attracts nearby enemies.",
		itemID = 18297,
		quality = 1,
	},
	--Engi.
	[44389] = {
		name = "Field Repair Bot 110G",
		icon = 133859,
		desc = "Unfolds into a Field Repair Bot that sells reagents and can repair damaged items.  After 10 minutes its internal motor fails.",
		itemID = 34113,
		quality = 1,
	},
	--Healthstones.
	[27235] = {
		name = "Master Healthstone",
		icon = 135230,
		desc = "Instantly restores 2080 life.",
		extraInfo = "0/2",
		itemID = 22103,
		quality = 1,
	},
	[27236] = {
		name = "Master Healthstone",
		icon = 135230,
		desc = "Instantly restores 2288 life.",
		extraInfo = "1/2",
		itemID = 22104,
		quality = 1,
	},
	[27237] = {
		name = "Master Healthstone",
		icon = 135230,
		desc = "Instantly restores 2496 life.",
		extraInfo = "2/2",
		itemID = 22105,
		quality = 1,
	},
	--Potions.
	[17531] = {
		name = "Major Mana Potion",
		icon = 134856,
		desc = "Restores 1350 to 2250 mana.",
		itemID = 13444,
		quality = 1,
	},
	[28499] = {
		name = "Super Mana Potion",
		icon = 134762,
		desc = "Restores 1800 to 3000 mana.",
		itemID = 22832,
		quality = 1,
	},
	[28495] = {
		name = "Super Healing Potion",
		icon = 134756,
		desc = "Restores 1500 to 2500 health.",
		itemID = 22829,
		quality = 1,
	},
	[28508] = {
		name = "Destruction Potion",
		icon = 134729,
		desc = "Increases spell critical chance by 2% and spell damage by 120 for 15 sec.",
		itemID = 22839,
		quality = 1,
	},
	[28507] = {
		name = "Haste Potion",
		icon = 134730,
		desc = "Increases haste rating by 400 for 15 sec.",
		itemID = 22838,
		quality = 1,
	},
	[28517] = {
		name = "Super Rejuvenation Potion",
		icon = 134759,
		desc = "Restores 1650 to 2750 mana and health.",
		itemID = 22850,
		quality = 1,
	},
	[45051] = {
		name = "Mad Alchemist's Potion",
		icon = 134808,
		desc = "Restores 1650 to 2750 mana and health. Sometimes has side effects.",
		itemID = 34440,
		quality = 1,
	},
	[28515] = {
		name = "Ironshield Potion",
		icon = 134758,
		desc = "Increases armor by 2500 for 2 min.",
		itemID = 22849,
		quality = 1,
	},
	[38929] = {
		name = "Fel Mana Potion",
		icon = 134763,
		desc = "Restores 3200 mana over 24 sec, but at a cost. Also reduces spell damage by 25 and healing done by 50 for 15 min.",
		itemID = 31677,
		quality = 1,
	},
	[28536] = {
		name = "Major Arcane Protection Potion",
		icon = 134752,
		desc = "Absorbs 2800 to 4000 arcane damage. Lasts 2 min.",
		itemID = 22845,
		quality = 1,
	},
	[28511] = {
		name = "Major Fire Protection Potion",
		icon = 134748,
		desc = "Absorbs 2800 to 4000 fire damage. Lasts 2 min.",
		itemID = 22841,
		quality = 1,
	},
	[28512] = {
		name = "Major Frost Protection Potion",
		icon = 134750,
		desc = "Absorbs 2800 to 4000 frost damage. Lasts 2 min.",
		itemID = 22841,
		quality = 1,
	},
	[28538] = {
		name = "Major Holy Protection Potion",
		icon = 134749,
		desc = "Absorbs 2800 to 4000 holy damage. Lasts 2 min.",
		itemID = 22847,
		quality = 1,
	},
	[28513] = {
		name = "Major Nature Protection Potion",
		icon = 134751,
		desc = "Absorbs 2800 to 4000 nature damage. Lasts 2 min.",
		itemID = 22844,
		quality = 1,
	},
	[22846] = {
		name = "Major Shadow Protection Potion",
		icon = 134747,
		desc = " Absorbs 2800 to 4000 shadow damage.  Lasts 2 min.",
		itemID = 22846,
		quality = 1,
	},
	[28548] = {
		name = "Shrouding Potion",
		icon = 134770,
		desc = "Shrouds you from nearby enemies so you seem less threatening to them.",
		itemID = 22871,
		quality = 1,
	},
	[28504] = {
		name = "Major Dreamless Sleep Potion",
		icon = 134764,
		desc = "Puts the imbiber in a dreamless sleep for 12 sec. During that time the imbiber heals 3600 health and 3600 mana.",
		itemID = 22836,
		quality = 1,
	},
	[38908] = {
		name = "Fel Regeneration Potion",
		icon = 134766,
		desc = " Restores 3200 health over 24 sec, but at a cost. All stats are reduced by 15 for 15 min.",
		itemID = 31676,
		quality = 1,
	},
	[28506] = {
		name = "Heroic Potion",
		icon = 134728,
		desc = "Increases Strength by 70 and temporarily increases health by 700 for 15 sec.",
		itemID = 22837,
		quality = 1,
	},
	[28494] = {
		name = "Insane Strength Potion",
		icon = 134731,
		desc = "Increases your Strength by 120 and decreases your defense rating by 75 for 15 sec.",
		itemID = 22828,
		quality = 1,
	},
	[28492] = {
		name = "Sneaking Potion",
		icon = 134733,
		desc = "Increases Stealth a great deal for 1 min.",
		itemID = 22826,
		quality = 1,
	},
	[11392] = {
		name = "Invisibility Potion",
		icon = 134805,
		desc = "Gives the imbiber invisibility for 18 sec. (10 Min Cooldown)",
		itemID = 9172,
		quality = 1,
	},
	[3680] = {
		name = "Lesser Invisibility Potion",
		icon = 134798,
		desc = "Gives the imbiber lesser invisibility for 15 sec. (10 Min Cooldown)",
		itemID = 3823,
		quality = 1,
	},
	[16666] = {
		name = "Demonic Rune",
		icon = 134417,
		desc = "Restores 900 to 1500 mana at the cost of 600 to 1000 life.",
		itemID = 12662,
		quality = 2,
	},
	[27869] = {
		name = "Dark Rune",
		icon = 136192,
		desc = "Restores 900 to 1500 mana at the cost of 600 to 1000 life.",
		itemID = 20520,
		quality = 2,
	},
	[28726] = {
		name = "Nightmare Seed",
		icon = 134217,
		desc = "Increases your health by 2000 for 30 sec",
	},
	--[[[] = {
		name = "",
		icon = ,
		desc = "",
	},]]
}

NRC.racials = {
	[20572] = {
		name = "Blood Fury",
		icon = 135726,
		desc = "Increases attack power by 6, but reduces healing effects on you by 50%. Lasts 15 sec.",
	},
	[33697] = {
		name = "Blood Fury",
		icon = 135726,
		desc = "Increases melee attack power by 6 and your damage and healing from spells and effects by up to 5, but reduces healing effects on you by 50%. Lasts 15 sec.",
	},
	[33702] = {
		name = "Blood Fury",
		icon = 135726,
		desc = "Increases your damage and healing from spells and effects by up to 5, but reduces healing effects on you by 50%.  Lasts 15 sec.",
	},
	[28730] = {
		name = "Arcane Torrent",
		icon = 136222,
		desc = "Silence all enemies within 8 yards for 2 sec.  In addition, you gain 10 Mana for each Mana Tap charge currently affecting you.",
	},
	[25046] = {
		name = "Arcane Torrent",
		icon = 136222,
		desc = "Silence all enemies within 8 yards for 2 sec.  In addition, you gain 10 Energy for each Mana Tap charge currently affecting you.",
	},
	[20549] = {
		name = "War Stomp",
		icon = 132368,
		desc = "Stuns up to 5 enemies within 8 yds for 2 sec.",
	},
	[26296] = {
		name = "Berserking",
		icon = 135727,
		desc = "Increases your attack speed by 10% to 30%. At full health the speed increase is 10% with a greater effect up to 30% if you are badly hurt when you activate Berserking. Lasts 10 sec.",
	},
	[7744] = {
		name = "Will of the Forsaken",
		icon = 136187,
		desc = "Provides immunity to Charm, Fear and Sleep while active. May also be used while already afflicted by Charm, Fear or Sleep. Lasts 5 sec.",
	},
	[28880] = {
		name = "Gift of the Naaru",
		icon = 135923,
		desc = "Heals the target for 20% of the caster's total health over 5 sec.",
	},
	[20594] = {
		name = "Stoneform",
		icon = 136225,
		desc = "Removes all harmful Poison, Disease, Curse, Magic, and Bleed effects and reduces all physical damage taken by 10% for 8 sec.",
	},
	[20589] = {
		name = "Escape Artist",
		icon = 132309,
		desc = "Escape the effects of any immobilization or movement speed reduction effect.",
	},
	[20600] = {
		name = "Perception",
		icon = 136090,
		desc = "Dramatically increases stealth detection for 20 sec.",
	},
	[20580] = {
		name = "Shadowmeld",
		icon = 132089,
		desc = "Activate to slip into the shadows, reducing the chance for enemies to detect your presence. Lasts until cancelled or upon moving. Night Elf Rogues and Druids with Shadowmeld are more difficult to detect while stealthed or prowling.",
	},
	[20577] = {
		name = "Cannibalize",
		icon = 132278,
		desc = "When activated, regenerates 7% of total health every 2 sec for 10 sec.",
	},
	[2481] = {
		name = "Find Treasure",
		icon = 135725,
		desc = "Allows the dwarf to sense nearby treasure, making it appear on the minimap.",
	},
}

NRC.interrupts = {
	--Id = threat.
	[1766] = {
		name = "Kick",
		icon = 132219,
		rank = 1,
	};
	[1767] = {
		name = "Kick",
		icon = 132219,
		rank = 2,
	};
	[1768] = {
		name = "Kick",
		icon = 132219,
		rank = 3,
	};
	[1769] = {
		name = "Kick",
		icon = 132219,
		rank = 4,
	};
	[38768] = {
		name = "Kick",
		icon = 132219,
		rank = 5,
	};
	[8042] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 1,
	};
	[8044] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 2,
	};
	[8045] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 3,
	};
	[8046] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 4,
	};
	[10412] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 5,
	};
	[10413] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 6,
	};
	[10414] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 7,
	};
	[25454] = {
		name = "Earth Shock",
		icon = 136026,
		rank = 8,
	};
	[2139] = {
		name = "Counterspell",
		icon = 135856,
	};
	[6552] = {
		name = "Pummel",
		icon = 132938,
		rank = 1,
	};
	[6554] = {
		name = "Pummel",
		icon = 132938,
		rank = 2,
	};
	[16979] = {
		name = "Feral Charge",
		icon = 132183,
	};
	[19244] = {
		name = "Spell Lock",
		icon = 136174,
		rank = 1,
	};
	[19647] = {
		name = "Spell Lock",
		icon = 136174,
		rank = 2,
	};
	[15487] = {
		name = "Silence",
		icon = 136164,
	};
};

NRC.trackedItems = {};
for k, v in pairs(NRC.scrolls) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.racials) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.battleElixirs) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.guardianElixirs) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.flasks) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.interrupts) do
	NRC.trackedItems[k] = v;
end
for k, v in pairs(NRC.trackedConsumes) do
	NRC.trackedItems[k] = v;
end
--for k, v in pairs(NRC.foods) do
--	NRC.trackedItems[k] = v;
--end

--Loot data here is taken from AtlasLoot with permission of the dev Lag123.
--HP data from wowhead but I also record when bosses are targeted incase any data is wrong or Blizzard change things.
NRC.npcs = {
	--Kara.
	[16181] = { --Create custom encounterIDs for these types of minibosses later? (For lookup purposes).
		name = "Rokad the Ravager", --No encounterID, basement mini-boss.
		encounterID = 0,
		instanceID = 532,
		hp = 227640,
		type = "Demon",
		loot = {
			[30684] = "Ravager's Cuffs",
			[30685] = "Ravager's Wrist-Wraps",
			[30686] = "Ravager's Bands",
			[30687] = "Ravager's Bracers",
		},
	},
	[16179] = {
		name = "Hyakiss the Lurker", --No encounterID, basement mini-boss.
		encounterID = 0,
		instanceID = 532,
		hp = 265580,
		type = "Beast",
		loot = {
			[30675] = "Lurker's Cord",
			[30676] = "Lurker's Grasp",
			[30677] = "Lurker's Belt",
			[30678] = "Lurker's Girdle",
		},
	},
	[16180] = {
		name = "Shadikith the Glider", --No encounterID, basement mini-boss.
		encounterID = 0,
		instanceID = 532,
		hp = 265580,
		type = "Beast",
		loot = {
			[30680] = "Glider's Foot-Wraps",
			[30681] = "Glider's Boots",
			[30682] = "Glider's Sabatons",
			[30683] = "Glider's Greaves",
		},
	},
	[16152] = {
		name = "Attumen the Huntsman",
		encounterID = 652,
		instanceID = 532,
		hp = 379400,
		type = "Undead",
		loot = {
			[28477] = "Harbinger Bands",
			[28507] = "Handwraps of Flowing Thought",
			[28508] = "Gloves of Saintly Blessings",
			[28453] = "Bracers of the White Stag",
			[28506] = "Gloves of Dexterous Manipulation",
			[28503] = "Whirlwind Bracers",
			[28454] = "Stalker's War Bands",
			[28502] = "Vambraces of Courage",
			[28505] = "Gauntlets of Renewed Hope",
			[28509] = "Worgen Claw Necklace",
			[28510] = "Spectral Band of Innervation",
			[28504] = "Steelhawk Crossbow",
			[30480] = "Fiery Warhorse's Reins",
			[23809] = "Schematic: Stabilized Eternium Scope",
		},
	},
	[16457] = {
		name = "Maiden of Virtue",
		encounterID = 654,
		instanceID = 532,
		hp = 424900,
		type = "",
		loot = {
			[28511] = "Bands of Indwelling",
			[28515] = "Bands of Nefarious Deeds",
			[28517] = "Boots of Foretelling",
			[28514] = "Bracers of Maliciousness",
			[28521] = "Mitts of the Treemender",
			[28520] = "Gloves of Centering",
			[28519] = "Gloves of Quickening",
			[28512] = "Bracers of Justice",
			[28518] = "Iron Gauntlets of the Maiden",
			[28516] = "Barbed Choker of Discipline",
			[28523] = "Totem of Healing Rains",
			[28522] = "Shard of the Virtuous",
		},
	},
	--[[[16151] = {
		name = "Midnight",
		encounterID = 0,
		instanceID = 532,
		hp = 379400,
		type = "Undead",
		loot = {
			--No loot, just the first part of Attumen boss.
		},
	},]]
	[15687] = {
		name = "Moroes",
		encounterID = 653,
		instanceID = 532,
		hp = 386988,
		type = "Undead",
		loot = {
			[28529] = "Royal Cloak of Arathi Kings",
			[28570] = "Shadow-Cloak of Dalaran",
			[28565] = "Nethershard Girdle",
			[28545] = "Edgewalker Longboots",
			[28567] = "Belt of Gale Force",
			[28566] = "Crimson Girdle of the Indomitable",
			[28569] = "Boots of Valiance",
			[28530] = "Brooch of Unquenchable Fury",
			[28528] = "Moroes' Lucky Pocket Watch",
			[28525] = "Signet of Unshakable Faith",
			[28568] = "Idol of the Avian Heart",
			[28524] = "Emerald Ripper",
			[22559] = "Formula: Enchant Weapon - Mongoose",
		},
	},
	[15689] = {
		name = "Netherspite",
		encounterID = 659,
		instanceID = 532,
		hp = 1117800,
		type = "Dragonkin",
		loot = {
			[28744] = "Uni-Mind Headdress",
			[28742] = "Pantaloons of Repentance",
			[28732] = "Cowl of Defiance",
			[28741] = "Skulker's Greaves",
			[28735] = "Earthblood Chestguard",
			[28740] = "Rip-Flayer Leggings",
			[28743] = "Mantle of Abrahmis",
			[28733] = "Girdle of Truth",
			[28731] = "Shining Chain of the Afterworld",
			[28730] = "Mithril Band of the Unscarred",
			[28734] = "Jewel of Infinite Possibilities",
			[28729] = "Spiteblade",
		},
	},
	[17225] = {
		name = "Nightbane",
		encounterID = 662,
		instanceID = 532,
		hp = 1327900,
		type = "Undead",
		loot = {
			[28602] = "Robe of the Elder Scribes",
			[28600] = "Stonebough Jerkin",
			[28601] = "Chestguard of the Conniver",
			[28599] = "Scaled Breastplate of Carnage",
			[28610] = "Ferocious Swift-Kickers",
			[28597] = "Panzar'Thar Breastplate",
			[28608] = "Ironstriders of Urgency",
			[31751] = "Blazing Signet",
			[24139] = "Faint Arcane Essence",
			[28609] = "Emberspur Talisman",
			[28603] = "Talisman of Nightbane",
			[28604] = "Nightstaff of the Everliving",
			[28611] = "Dragonheart Flameshield",
			[28606] = "Shield of Impenetrable Darkness",
		},
	},
	[15690] = {
		name = "Prince Malchezaar",
		encounterID = 661,
		instanceID = 532,
		hp = 1138200,
		type = "Demon",
		loot = {
			[28765] = "Stainless Cloak of the Pure Hearted",
			[28766] = "Ruby Drape of the Mysticant",
			[28764] = "Farstrider Wildercloak",
			[28762] = "Adornment of Stolen Souls",
			[28763] = "Jade Ring of the Everliving",
			[28757] = "Ring of a Thousand Marks",
			[28770] = "Nathrezim Mindblade",
			[28768] = "Malchazeen",
			[28767] = "The Decapitator",
			[28773] = "Gorehowl",
			[28771] = "Light's Justice",
			[28772] = "Sunfury Bow of the Phoenix",
			[29760] = "Helm of the Fallen Champion",
			[29761] = "Helm of the Fallen Defender",
			[29759] = "Helm of the Fallen Hero",
		},
	},
	[16524] = {
		name = "Shade of Aran",
		encounterID = 658,
		instanceID = 532,
		hp = 849760,
		type = "Undead",
		loot = {
			[28672] = "Drape of the Dark Reavers",
			[28726] = "Mantle of the Mind Flayer",
			[28670] = "Boots of the Infernal Coven",
			[28663] = "Boots of the Incorrupt",
			[28669] = "Rapscallion Boots",
			[28671] = "Steelspine Faceguard",
			[28666] = "Pauldrons of the Justice-Seeker",
			[23933] = "Medivh's Journal",
			[28674] = "Saberclaw Talisman",
			[28675] = "Shermanar Great-Ring",
			[28727] = "Pendant of the Violet Eye",
			[28728] = "Aran's Soothing Sapphire",
			[28673] = "Tirisfal Wand of Ascendancy",
			[22560] = "Formula: Enchant Weapon - Sunfire",
		},
	},
	[15688] = {
		name = "Terestian Illhoof",
		encounterID = 657,
		instanceID = 532,
		hp = 698600,
		type = "Demon",
		loot = {
			[28660] = "Gilded Thorium Cloak",
			[28653] = "Shadowvine Cloak of Infusion",
			[28652] = "Cincture of Will",
			[28654] = "Malefic Girdle",
			[28655] = "Cord of Nature's Sustenance",
			[28656] = "Girdle of the Prowler",
			[28662] = "Breastplate of the Lightbinder",
			[28661] = "Mender's Heart-Ring",
			[28785] = "The Lightning Capacitor",
			[28657] = "Fool's Bane",
			[28658] = "Terestian's Stranglestaff",
			[28659] = "Xavian Stiletto",
			[22561] = "Formula: Enchant Weapon - Soulfrost",
		},
	},
	[15691] = {
		name = "The Curator",
		encounterID = 656,
		instanceID = 532,
		hp = 698050,
		type = "Mechanical",
		loot = {
			[28612] = "Pauldrons of the Solace-Giver",
			[28647] = "Forest Wind Shoulderpads",
			[28631] = "Dragon-Quake Shoulderguards",
			[28621] = "Wrynn Dynasty Greaves",
			[28649] = "Garona's Signet Ring",
			[28633] = "Staff of Infinite Mysteries",
			[29757] = "Gloves of the Fallen Champion",
			[29758] = "Gloves of the Fallen Defender",
			[29756] = "Gloves of the Fallen Hero",
		},
	},
	[17521] = {
		name = "The Big Bad Wolf", --Opera Hall.
		encounterID = 655,
		instanceID = 532,
		hp = 379400,
		type = "Humanoid",
		loot = {
			[28582] = "Red Riding Hood's Cloak",
			[28583] = "Big Bad Wolf's Head",
			[28584] = "Big Bad Wolf's Paw",
			[28581] = "Wolfslayer Sniper Rifle",
			[28594] = "Trial-Fire Trousers",
			[28591] = "Earthsoul Leggings",
			[28589] = "Beastmaw Pauldrons",
			[28593] = "Eternium Greathelm",
			[28590] = "Ribbon of Sacrifice",
			[28592] = "Libram of Souls Redeemed",
		},
	},
	[18168] = {
		name = "The Crone", --Opera Hall.
		encounterID = 655,
		instanceID = 532,
		hp = 151750,
		type = "Humanoid",
		loot = {
			[28586] = "Wicked Witch's Hat",
			[28585] = "Ruby Slippers",
			[28587] = "Legacy",
			[28588] = "Blue Diamond Witchwand",
			[28594] = "Trial-Fire Trousers",
			[28591] = "Earthsoul Leggings",
			[28589] = "Beastmaw Pauldrons",
			[28593] = "Eternium Greathelm",
			[28590] = "Ribbon of Sacrifice",
			[28592] = "Libram of Souls Redeemed",
		},
	},
	[17534] = {
		name = "Julianne", --Opera Hall.
		encounterID = 655,
		instanceID = 532,
		hp = 151750,
		type = "Undead",
		loot = {
			[28579] = "Romulo's Poison Vial",
			[28573] = "Despair",
			[28578] = "Masquerade Gown",
			[28572] = "Blade of the Unrequited",
		},
	},
	[17533] = {
		name = "Romulo", --Opera Hall.
		encounterID = 655,
		instanceID = 532,
		hp = 189700,
		type = "Undead",
		loot = {
			[28594] = "Trial-Fire Trousers",
			[28591] = "Earthsoul Leggings",
			[28589] = "Beastmaw Pauldrons",
			[28593] = "Eternium Greathelm",
			[28590] = "Ribbon of Sacrifice",
			[28592] = "Libram of Souls Redeemed",
		},
	},
	--[[[17543] = {
		name = "Strawman",
		encounterID = 0,
		instanceID = 532,
		hp = 110700,
		type = "Humanoid",
		loot = {
			--No loot, part of the The Crone (Wizard of oz) opera event.
		},
	},
	[17535] = {
		name = "Dorothee",
		encounterID = 0,
		instanceID = 532,
		hp = 151750,
		type = "",
		loot = {
			--No loot, part of the The Crone (Wizard of oz) opera event.
		},
	},
	[17547] = {
		name = "Tinhead",
		encounterID = 0,
		instanceID = 532,
		hp = 110700,
		type = "Mechanical",
		loot = {
			--No loot, part of the The Crone (Wizard of oz) opera event.
		},
	},
	[17546] = {
		name = "Roar",
		encounterID = 0,
		instanceID = 532,
		hp = 110700,
		type = "Beast",
		loot = {
			--No loot, part of the The Crone (Wizard of oz) opera event.
		},
	},
	[17548] = {
		name = "Tito",
		encounterID = 0,
		instanceID = 532,
		hp = 34930,
		type = "Beast",
		loot = {
			--No loot, part of the The Crone (Wizard of oz) opera event.
		},
	},]]
	--[[[0] = { --Kara trash.
			[30642] = "Drape of the Righteous",
			[30668] = "Grasp of the Dead",
			[30673] = "Inferno Waist Cord",
			[30644] = "Grips of Deftness",
			[30674] = "Zierhut's Lost Treads",
			[30643] = "Belt of the Tracker",
			[30641] = "Boots of Elusion",
			[23857] = "Legacy of the Mountain King",
			[23864] = "Torment of the Worgen",
			[23862] = "Redemption of the Fallen",
			[23865] = "Wrath of the Titans",
			[21882] = "Soul Essence",
			[30666] = "Ritssyn's Lost Pendant",
			[30667] = "Ring of Unrelenting Storms",
			[21903] = "Pattern: Soulcloth Shoulders",
			[21904] = "Pattern: Soulcloth Vest",
			[22545] = "Formula: Enchant Boots - Surefooted",
    },]]
	--Gruul's lair.
	[19044] = {
		name = "Gruul the Dragonkiller",
		encounterID = 650,
		instanceID = 565,
		hp = 4552800,
		type = "Humanoid",
		loot = {
			[28804] = "Collar of Cho'gall",
			[28803] = "Cowl of Nature's Breath",
			[28828] = "Gronn-Stitched Girdle",
			[28827] = "Gauntlets of the Dragonslayer",
			[28810] = "Windshear Boots",
			[28824] = "Gauntlets of Martial Perfection",
			[28822] = "Teeth of Gruul",
			[28823] = "Eye of Gruul",
			[28830] = "Dragonspine Trophy",
			[31750] = "Earthen Signet",
			[29766] = "Leggings of the Fallen Champion",
			[29767] = "Leggings of the Fallen Defender",
			[29765] = "Leggings of the Fallen Hero",
			[28802] = "Bloodmaw Magus-Blade",
			[28794] = "Axe of the Gronn Lords",
			[28825] = "Aldori Legacy Defender",
			[28826] = "Shuriken of Negation",
		},
	},
	[18831] = {
		name = "High King Maulgar",
		encounterID = 649,
		instanceID = 565,
		hp = 758800,
		type = "Humanoid",
		loot = {
			[28797] = "Brute Cloak of the Ogre-Magi",
			[28799] = "Belt of Divine Inspiration",
			[28796] = "Malefic Mask of the Shadows",
			[28801] = "Maulgar's Warhelm",
			[28795] = "Bladespire Warbands",
			[28800] = "Hammer of the Naaru",
			[29763] = "Pauldrons of the Fallen Champion",
			[29764] = "Pauldrons of the Fallen Defender",
			[29762] = "Pauldrons of the Fallen Hero",
		},
	},
	--[[[18836] = {
		name = "Blindeye the Seer",
		encounterID = 0,
		instanceID = 565,
		hp = 303500,
		type = "Humanoid",
		class = "PRIEST",
		loot = {
			--No loot, part of High King Maulgar fight.
		},
	},
	[18835] = {
		name = "Kiggler the Crazed",
		encounterID = 0,
		instanceID = 565,
		hp = 303500,
		type = "Humanoid",
		class = "SHAMAN",
		loot = {
			--No loot, part of High King Maulgar fight.
		},
	},
	[18832] = {
		name = "Krosh Firehand",
		encounterID = 0,
		instanceID = 565,
		hp = 303500,
		type = "Humanoid",
		class = "MAGE",
		loot = {
			--No loot, part of High King Maulgar fight.
		},
	},
	[18834] = {
		name = "Olm the Summoner",
		encounterID = 0,
		instanceID = 565,
		hp = 303500,
		type = "Humanoid",
		class = "WARLOCK",
		loot = {
			--No loot, part of High King Maulgar fight.
		},
	},]]
	--Magtheridon's Lair.
	[17257] = {
		name = "Magtheridon",
		encounterID = 651,
		instanceID = 544,
		hp = 4818380,
		type = "Demon",
		loot = {
			[28777] = "Cloak of the Pit Stalker",
			[28780] = "Soul-Eater's Handwraps",
			[28776] = "Liar's Tongue Gloves",
			[28778] = "Terror Pit Girdle",
			[28775] = "Thundering Greathelm",
			[28779] = "Girdle of the Endless Pit",
			[28789] = "Eye of Magtheridon",
			[28781] = "Karaborian Talisman",
			[28774] = "Glaive of the Pit",
			[28782] = "Crystalheart Pulse-Staff",
			[29458] = "Aegis of the Vindicator",
			[28783] = "Eredar Wand of Obliteration",
			[29754] = "Chestguard of the Fallen Champion",
			[29753] = "Chestguard of the Fallen Defender",
			[29755] = "Chestguard of the Fallen Hero",
			[32385] = "Magtheridon's Head",
			[34845] = "Pit Lord's Satchel",
			[34846] = "Black Sack of Gems",
		},
	},
	--Serpentshrine Cavern.
	[21216] = {
		name = "Hydross the Unstable",
		encounterID = 623,
		instanceID = 548,
		hp = 3794000,
		type = "Elemental",
		loot = {
			[30056] = "Robe of Hateful Echoes",
			[32516] = "Wraps of Purification",
			[30050] = "Boots of the Shifting Nightmare",
			[30055] = "Shoulderpads of the Stranger",
			[30047] = "Blackfathom Warbands",
			[30054] = "Ranger-General's Chestguard",
			[30048] = "Brighthelm of Justice",
			[30053] = "Pauldrons of the Wardancer",
			[30052] = "Ring of Lethality",
			[33055] = "Band of Vile Aggression",
			[30664] = "Living Root of the Wildheart",
			[30629] = "Scarab of Displacement",
			[30049] = "Fathomstone",
			[30051] = "Idol of the Crescent Goddess",
		},
	},
	[21217] = {
		name = "The Lurker Below",
		encounterID = 624,
		instanceID = 548,
		hp = 5311600,
		type = "Beast",
		loot = {
			[30064] = "Cord of Screaming Terrors",
			[30067] = "Velvet Boots of the Guardian",
			[30062] = "Grove-Bands of Remulos",
			[30060] = "Boots of Effortless Striking",
			[30066] = "Tempest-Strider Boots",
			[30065] = "Glowing Breastplate of Truth",
			[30057] = "Bracers of Eradication",
			[30059] = "Choker of Animalistic Fury",
			[30061] = "Ancestral Ring of Conquest",
			[33054] = "The Seal of Danzalar",
			[30665] = "Earring of Soulful Meditation",
			[30063] = "Libram of Absolute Truth",
			[30058] = "Mallet of the Tides",
		},
	},
	[21215] = {
		name = "Leotheras the Blind",
		encounterID = 625,
		instanceID = 548,
		hp = 4552800,
		type = "Humanoid",
		loot = {
			[30092] = "Orca-Hide Boots",
			[30097] = "Coral-Barbed Shoulderpads",
			[30091] = "True-Aim Stalker Bands",
			[30096] = "Girdle of the Invulnerable",
			[30627] = "Tsunami Talisman",
			[30095] = "Fang of the Leviathan",
			[30239] = "Gloves of the Vanquished Champion",
			[30240] = "Gloves of the Vanquished Defender",
			[30241] = "Gloves of the Vanquished Hero",
		},
	},
	[21214] = {
		name = "Fathom-Lord Karathress",
		encounterID = 626,
		instanceID = 548,
		hp = 1821000,
		type = "Humanoid",
		loot = {
			[30100] = "Soul-Strider Boots",
			[30101] = "Bloodsea Brigand's Vest",
			[30099] = "Frayed Tether of the Drowned",
			[30663] = "Fathom-Brooch of the Tidewalker",
			[30626] = "Sextant of Unstable Currents",
			[30090] = "World Breaker",
			[30245] = "Leggings of the Vanquished Champion",
			[30246] = "Leggings of the Vanquished Defender",
			[30247] = "Leggings of the Vanquished Hero",
		},
	},
	[21213] = {
		name = "Morogrim Tidewalker",
		encounterID = 627,
		instanceID = 548,
		hp = 5691000,
		type = "Giant",
		loot = {
			[30098] = "Razor-Scale Battlecloak",
			[30079] = "Illidari Shoulderpads",
			[30075] = "Gnarled Chestpiece of the Ancients",
			[30085] = "Mantle of the Tireless Tracker",
			[30068] = "Girdle of the Tidal Call",
			[30084] = "Pauldrons of the Argent Sentinel",
			[30081] = "Warboots of Obliteration",
			[30008] = "Pendant of the Lost Ages",
			[30083] = "Ring of Sundered Souls",
			[33058] = "Band of the Vigilant",
			[30720] = "Serpent-Coil Braid",
			[30082] = "Talon of Azshara",
			[30080] = "Luminescent Rod of the Naaru",
		},
	},
	[21212] = {
		name = "Lady Vashj",
		encounterID = 628,
		instanceID = 548,
		hp = 6070000,
		type = "Humanoid",
		loot = {
			[30107] = "Vestments of the Sea-Witch",
			[30111] = "Runetotem's Mantle",
			[30106] = "Belt of One-Hundred Deaths",
			[30104] = "Cobra-Lash Boots",
			[30102] = "Krakken-Heart Breastplate",
			[30112] = "Glorious Gauntlets of Crestfall",
			[30109] = "Ring of Endless Coils",
			[30110] = "Coral Band of the Revived",
			[30621] = "Prism of Inner Calm",
			[30103] = "Fang of Vashj",
			[30108] = "Lightfathom Scepter",
			[30105] = "Serpent Spine Longbow",
			[30242] = "Helm of the Vanquished Champion",
			[30243] = "Helm of the Vanquished Defender",
			[30244] = "Helm of the Vanquished Hero",
			[29906] = "Vashj's Vial Remnant",
		},
	},
	--[[[21966] = {
		name = "Fathom-Guard Sharkkis",
		encounterID = 0,
		instanceID = 548,
		hp = 861600,
		type = "Humanoid",
		loot = {
			--No loot, part of Fathom-Lord Karathress.
		},
	},
	[21965] = {
		name = "Fathom-Guard Tidalvess",
		encounterID = 0,
		instanceID = 548,
		hp = 861600,
		type = "Humanoid",
		loot = {
			--No loot, part of Fathom-Lord Karathress.
		},
	},
	[21964] = {
		name = "Fathom-Guard Caribdis",
		encounterID = 0,
		instanceID = 548,
		hp = 861600,
		type = "Humanoid",
		loot = {
			--No loot, part of Fathom-Lord Karathress.
		},
	},]]
	--[[[0] = { --Scc trash.
			[30027] = "Boots of Courage Unending",
			[30022] = "Pendant of the Perilous",
			[30620] = "Spyglass of the Hidden Fleet",
			[30023] = "Totem of the Maelstrom",
			[30021] = "Wildfury Greatstaff",
			[30025] = "Serpentshrine Shuriken",
			[30324] = "Plans: Red Havoc Boots",
			[30322] = "Plans: Red Belt of Battle",
			[30323] = "Plans: Boots of the Protector",
			[30321] = "Plans: Belt of the Guardian",
			[30280] = "Pattern: Belt of Blasting",
			[30282] = "Pattern: Boots of Blasting",
			[30283] = "Pattern: Boots of the Long Road",
			[30281] = "Pattern: Belt of the Long Road",
			[30308] = "Pattern: Hurricane Boots",
			[30304] = "Pattern: Monsoon Belt",
			[30305] = "Pattern: Boots of Natural Grace",
			[30307] = "Pattern: Boots of the Crimson Hawk",
			[30306] = "Pattern: Boots of Utter Darkness",
			[30301] = "Pattern: Belt of Natural Power",
			[30303] = "Pattern: Belt of the Black Eagle",
			[30302] = "Pattern: Belt of Deep Shadow",
			[30183] = "Nether Vortex",
			[32897] = "Mark of the Illidari",
	},]]
	--Tempest Keep.
	[19514] = {
		name = "Al'ar",
		encounterID = 730,
		instanceID = 550,
		hp = 3414600,
		type = "Elemental",
		loot = {
			[29925] = "Phoenix-Wing Cloak",
			[29918] = "Mindstorm Wristbands",
			[29947] = "Gloves of the Searing Grip",
			[29921] = "Fire Crest Breastplate",
			[29922] = "Band of Al'ar",
			[29920] = "Phoenix-Ring of Rebirth",
			[30448] = "Talon of Al'ar",
			[30447] = "Tome of Fiery Redemption",
			[29923] = "Talisman of the Sun King",
			[32944] = "Talon of the Phoenix",
			[29948] = "Claw of the Phoenix",
			[29924] = "Netherbane",
			[29949] = "Arcanite Steam-Pistol",
		},
	},
	[19516] = {
		name = "Void Reaver",
		encounterID = 731,
		instanceID = 550,
		hp = 4552500,
		type = "Mechanical",
		loot = {
			[29986] = "Cowl of the Grand Engineer",
			[29984] = "Girdle of Zaetar",
			[29985] = "Void Reaver Greaves",
			[29983] = "Fel-Steel Warhelm",
			[32515] = "Wristguards of Determination",
			[30619] = "Fel Reaver's Piston",
			[30450] = "Warp-Spring Coil",
			[30248] = "Pauldrons of the Vanquished Champion",
			[30249] = "Pauldrons of the Vanquished Defender",
			[30250] = "Pauldrons of the Vanquished Hero",
		},
	},
	[18805] = {
		name = "High Astromancer Solarian",
		encounterID = 732,
		instanceID = 550,
		hp = 4552500,
		type = "Humanoid",
		loot = {
			[29977] = "Star-Soul Breeches",
			[29972] = "Trousers of the Astromancer",
			[29966] = "Vambraces of Ending",
			[29976] = "Worldstorm Gauntlets",
			[29951] = "Star-Strider Boots",
			[29965] = "Girdle of the Righteous Path",
			[29950] = "Greaves of the Bloodwarder",
			[32267] = "Boots of the Resilient",
			[30446] = "Solarian's Sapphire",
			[30449] = "Void Star Talisman",
			[29962] = "Heartrazor",
			[29981] = "Ethereum Life-Staff",
			[29982] = "Wand of the Forgotten Star",
		},
	},
	[19622] = {
		name = "Kael'thas Sunstrider",
		encounterID = 733,
		instanceID = 550,
		hp = 6070000,
		type = "Humanoid",
		loot = {
			[29992] = "Royal Cloak of the Sunstriders",
			[29989] = "Sunshower Light Cloak",
			[29994] = "Thalassian Wildercloak",
			[29990] = "Crown of the Sun",
			[29987] = "Gauntlets of the Sun King",
			[29995] = "Leggings of Murderous Intent",
			[29991] = "Sunhawk Leggings",
			[29998] = "Royal Gauntlets of Silvermoon",
			[29997] = "Band of the Ranger-General",
			[29993] = "Twinblade of the Phoenix",
			[29996] = "Rod of the Sun King",
			[29988] = "The Nexus Key",
			[30236] = "Chestguard of the Vanquished Champion",
			[30237] = "Chestguard of the Vanquished Defender",
			[30238] = "Chestguard of the Vanquished Hero",
			[32458] = "Ashes of Al'ar",
			[32405] = "Verdant Sphere",
			[29905] = "Kael's Vial Remnant",
			--Legendaries.
			--[[[30312] = "Infinity Blade",
			[30311] = "Warp Slicer",
			[30317] = "Cosmic Infuser",
			[30316] = "Devastation",
			[30313] = "Staff of Disintegration",
			[30314] = "Phaseshift Bulwark",
			[30318] = "Netherstrand Longbow",
			[30319] = "Nether Spike",]]
		},
	},
	--[[[20064] = {
		name = "Thaladred the Darkener",
		encounterID = 0,
		instanceID = 550,
		hp = 758,800,
		type = "Humanoid",
		loot = {
			--No loot, part of Kael'thas Sunstrider.
		},
	},
	[20060] = {
		name = "Lord Sanguinar",
		encounterID = 0,
		instanceID = 550,
		hp = 758800,
		type = "Humanoid",
		loot = {
			--No loot, part of Kael'thas Sunstrider.
		},
	},
	[20062] = {
		name = "Grand Astromancer Capernian",
		encounterID = 0,
		instanceID = 550,
		hp = 531100,
		type = "Humanoid",
		loot = {
			--No loot, part of Kael'thas Sunstrider.
		},
	},
	[20063] = {
		name = "Master Engineer Telonicus",
		encounterID = 0,
		instanceID = 550,
		hp = 758800,
		type = "Humanoid",
		loot = {
			--No loot, part of Kael'thas Sunstrider.
		},
	},]]
	--[[[0] = { --KT trash.
			[30024] = "Mantle of the Elven Kings",
			[30020] = "Fire-Cord of the Magus",
			[30029] = "Bark-Gloves of Ancient Wisdom",
			[30026] = "Bands of the Celestial Archer",
			[30030] = "Girdle of Fallen Stars",
			[30028] = "Seventh Ring of the Tirisfalen",
			[30324] = "Plans: Red Havoc Boots",
			[30322] = "Plans: Red Belt of Battle",
			[30323] = "Plans: Boots of the Protector",
			[30321] = "Plans: Belt of the Guardian",
			[30280] = "Pattern: Belt of Blasting",
			[30282] = "Pattern: Boots of Blasting",
			[30283] = "Pattern: Boots of the Long Road",
			[30281] = "Pattern: Belt of the Long Road",
			[30308] = "Pattern: Hurricane Boots",
			[30304] = "Pattern: Monsoon Belt",
			[30305] = "Pattern: Boots of Natural Grace",
			[30307] = "Pattern: Boots of the Crimson Hawk",
			[30306] = "Pattern: Boots of Utter Darkness",
			[30301] = "Pattern: Belt of Natural Power",
			[30303] = "Pattern: Belt of the Black Eagle",
			[30302] = "Pattern: Belt of Deep Shadow",
			[30183] = "Nether Vortex",
			[32897] = "Mark of the Illidari",
	--},]]
	--Hyjal Summit.
	[17767] = {
		name = "Rage Winterchill",
		encounterID = 618,
		instanceID = 534,
		hp = 0,
		type = "Undead",
		loot = {
			[30871] = "Bracers of Martyrdom",
			[30870] = "Cuffs of Devastation",
			[30863] = "Deadly Cuffs",
			[30868] = "Rejuvenating Bracers",
			[30864] = "Bracers of the Pathfinder",
			[30869] = "Howling Wind Bracers",
			[30873] = "Stillwater Boots",
			[30866] = "Blood-stained Pauldrons",
			[30862] = "Blessed Adamantite Bracers",
			[30861] = "Furious Shackles",
			[30865] = "Tracker's Blade",
			[30872] = "Chronicle of Dark Secrets",
			[32459] = "Time-Phased Phylactery",
		},
	},
	[17808] = {
		name = "Anetheron",
		encounterID = 619,
		instanceID = 534,
		hp = 0,
		type = "Demon",
		loot = {
			[30884] = "Hatefury Mantle",
			[30888] = "Anetheron's Noose",
			[30885] = "Archbishop's Slippers",
			[30879] = "Don Alejandro's Money Belt",
			[30886] = "Enchanted Leather Sandals",
			[30887] = "Golden Links of Restoration",
			[30880] = "Quickstrider Moccasins",
			[30878] = "Glimmering Steel Mantle",
			[30874] = "The Unbreakable Will",
			[30881] = "Blade of Infamy",
			[30883] = "Pillar of Ferocity",
			[30882] = "Bastion of Light",
		},
	},
	[17888] = {
		name = "Kaz'rogal",
		encounterID = 620,
		instanceID = 534,
		hp = 0,
		type = "Demon",
		loot = {
			[30895] = "Angelista's Sash",
			[30916] = "Leggings of Channeled Elements",
			[30894] = "Blue Suede Shoes",
			[30917] = "Razorfury Mantle",
			[30914] = "Belt of the Crescent Moon",
			[30891] = "Black Featherlight Boots",
			[30892] = "Beast-tamer's Shoulders",
			[30919] = "Valestalker Girdle",
			[30893] = "Sun-touched Chain Leggings",
			[30915] = "Belt of Seething Fury",
			[30918] = "Hammer of Atonement",
			[30889] = "Kaz'rogal's Hardened Heart",
		},
	},
	[17842] = {
		name = "Azgalor",
		encounterID = 621,
		instanceID = 534,
		hp = 0,
		type = "Demon",
		loot = {
			[30899] = "Don Rodrigo's Poncho",
			[30898] = "Shady Dealer's Pantaloons",
			[30900] = "Bow-stitched Leggings",
			[30896] = "Glory of the Defender",
			[30897] = "Girdle of Hope",
			[30901] = "Boundless Agony",
			[31092] = "Gloves of the Forgotten Conqueror",
			[31094] = "Gloves of the Forgotten Protector",
			[31093] = "Gloves of the Forgotten Vanquisher",
		},
	},
	[17968] = {
		name = "Archimonde",
		encounterID = 622,
		instanceID = 534,
		hp = 0,
		type = "Demon",
		loot = {
			[30913] = "Robes of Rhonin",
			[30912] = "Leggings of Eternity",
			[30905] = "Midnight Chestguard",
			[30907] = "Mail of Fevered Pursuit",
			[30904] = "Savior's Grasp",
			[30903] = "Legguards of Endless Rage",
			[30911] = "Scepter of Purification",
			[30910] = "Tempest of Chaos",
			[30902] = "Cataclysm's Edge",
			[30908] = "Apostle of Argus",
			[30909] = "Antonidas's Aegis of Rapt Concentration",
			[30906] = "Bristleblitz Striker",
			[31097] = "Helm of the Forgotten Conqueror",
			[31095] = "Helm of the Forgotten Protector",
			[31096] = "Helm of the Forgotten Vanquisher",
		},
	},
	--[[[0] = { --Hyjal trash.
			[32590] = "Nethervoid Cloak",
			[34010] = "Pepe's Shroud of Pacification",
			[32609] = "Boots of the Divine Light",
			[32592] = "Chestguard of Relentless Storms",
			[32591] = "Choker of Serrated Blades",
			[32589] = "Hellfire-Encased Pendant",
			[34009] = "Hammer of Judgement",
			[32946] = "Claw of Molten Fury",
			[32945] = "Fist of Molten Fury",
			[32428] = "Heart of Darkness",
			[32897] = "Mark of the Illidari",
			[32285] = "Design: Flashing Crimson Spinel",
			[32296] = "Design: Great Lionseye",
			[32303] = "Design: Inscribed Pyrestone",
			[32295] = "Design: Mystic Lionseye",
			[32298] = "Design: Shifting Shadowsong Amethyst",
			[32297] = "Design: Sovereign Shadowsong Amethyst",
			[32289] = "Design: Stormy Empyrean Sapphire",
			[32307] = "Design: Veiled Pyrestone",
	--},]]
	--Black Temple.
	[22948] = {
		name = "Gurtogg Bloodboil",
		encounterID = 605,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			[32337] = "Shroud of Forgiveness",
			[32338] = "Blood-cursed Shoulderpads",
			[32340] = "Garments of Temperance",
			[32339] = "Belt of Primal Majesty",
			[32334] = "Vest of Mounting Assault",
			[32342] = "Girdle of Mighty Resolve",
			[32333] = "Girdle of Stability",
			[32341] = "Leggings of Divine Retribution",
			[32335] = "Unstoppable Aggressor's Ring",
			[32501] = "Shadowmoon Insignia",
			[32269] = "Messenger of Fate",
			[32344] = "Staff of Immaculate Recovery",
			[32343] = "Wand of Prismatic Focus",
		},
	},
	[22887] = {
		name = "High Warlord Naj'entus",
		encounterID = 601,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			[32239] = "Slippers of the Seacaller",
			[32240] = "Guise of the Tidal Lurker",
			[32377] = "Mantle of Darkness",
			[32241] = "Helm of Soothing Currents",
			[32234] = "Fists of Mukoa",
			[32242] = "Boots of Oceanic Fury",
			[32232] = "Eternium Shell Bracers",
			[32243] = "Pearl Inlaid Boots",
			[32245] = "Tide-stomper's Greaves",
			[32238] = "Ring of Calming Waves",
			[32247] = "Ring of Captured Storms",
			[32237] = "The Maelstrom's Fury",
			[32236] = "Rising Tide",
			[32248] = "Halberd of Desolation",
		},
	},
	[22917] = {
		name = "Illidan Stormrage",
		encounterID = 609,
		instanceID = 564,
		hp = 0,
		type = "Demon",
		loot = {
			[32524] = "Shroud of the Highborne",
			[32525] = "Cowl of the Illidari High Lord",
			[32235] = "Cursed Vision of Sargeras",
			[32521] = "Faceplate of the Impenetrable",
			[32497] = "Stormrage Signet Ring",
			[32483] = "The Skull of Gul'dan",
			[32496] = "Memento of Tyrande",
			[32837] = "Warglaive of Azzinoth",
			[32838] = "Warglaive of Azzinoth",
			[31089] = "Chestguard of the Forgotten Conqueror",
			[31091] = "Chestguard of the Forgotten Protector",
			[31090] = "Chestguard of the Forgotten Vanquisher",
			[32471] = "Shard of Azzinoth",
			[32500] = "Crystal Spire of Karabor",
			[32374] = "Zhar'doom, Greatstaff of the Devourer",
			[32375] = "Bulwark of Azzinoth",
			[32336] = "Black Bow of the Betrayer",
		},
	},
	[22947] = {
		name = "Mother Shahraz",
		encounterID = 607,
		instanceID = 564,
		hp = 0,
		type = "Demon",
		loot = {
			[32367] = "Leggings of Devastation",
			[32366] = "Shadowmaster's Boots",
			[32365] = "Heartshatter Breastplate",
			[32370] = "Nadina's Pendant of Purity",
			[32368] = "Tome of the Lightbringer",
			[32369] = "Blade of Savagery",
			[31101] = "Pauldrons of the Forgotten Conqueror",
			[31103] = "Pauldrons of the Forgotten Protector",
			[31102] = "Pauldrons of the Forgotten Vanquisher",
		},
	},
	[22841] = {
		name = "Shade of Akama",
		encounterID = 603,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			[32273] = "Amice of Brilliant Light",
			[32270] = "Focused Mana Bindings",
			[32513] = "Wristbands of Divine Influence",
			[32265] = "Shadow-walker's Cord",
			[32271] = "Kilt of Immortal Nature",
			[32264] = "Shoulders of the Hidden Predator",
			[32275] = "Spiritwalker Gauntlets",
			[32276] = "Flashfire Girdle",
			[32279] = "The Seeker's Wristguards",
			[32278] = "Grips of Silent Justice",
			[32263] = "Praetorian's Legguards",
			[32268] = "Myrmidon's Treads",
			[32266] = "Ring of Deceitful Intent",
			[32361] = "Blind-Seers Icon",
		},
	},
	[22898] = {
		name = "Supremus",
		encounterID = 602,
		instanceID = 564,
		hp = 0,
		type = "Demon",
		loot = {
			[32256] = "Waistwrap of Infinity",
			[32252] = "Nether Shadow Tunic",
			[32259] = "Bands of the Coming Storm",
			[32251] = "Wraps of Precise Flight",
			[32258] = "Naturalist's Preserving Cinch",
			[32250] = "Pauldrons of Abyssal Fury",
			[32260] = "Choker of Endless Nightmares",
			[32261] = "Band of the Abyssal Lord",
			[32257] = "Idol of the White Stag",
			[32254] = "The Brutalizer",
			[32262] = "Syphon of the Nathrezim",
			[32255] = "Felstone Bulwark",
			[32253] = "Legionkiller",
		},
	},
	[22871] = {
		name = "Teron Gorefiend",
		encounterID = 604,
		instanceID = 564,
		hp = 0,
		type = "Undead",
		loot = {
			[32323] = "Shadowmoon Destroyer's Drape",
			[32329] = "Cowl of Benevolence",
			[32327] = "Robe of the Shadow Council",
			[32324] = "Insidious Bands",
			[32328] = "Botanist's Gloves of Growth",
			[32510] = "Softstep Boots of Tracking",
			[32280] = "Gauntlets of Enforcement",
			[32512] = "Girdle of Lordaeron's Fallen",
			[32330] = "Totem of Ancestral Guidance",
			[32348] = "Soul Cleaver",
			[32326] = "Twisted Blades of Zarak",
			[32325] = "Rifle of the Stoic Guardian",
		},
	},
	--[[[23426] = { --Is this an actual npc?
		name = "The Illidari Council",
		encounterID = 608,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			[32331] = "Cloak of the Illidari Council",
			[32519] = "Belt of Divine Guidance",
			[32518] = "Veil of Turning Leaves",
			[32376] = "Forest Prowler's Helm",
			[32373] = "Helm of the Illidari Shatterer",
			[32505] = "Madness of the Betrayer",
			[31098] = "Leggings of the Forgotten Conqueror",
			[31100] = "Leggings of the Forgotten Protector",
			[31099] = "Leggings of the Forgotten Vanquisher",
		},
	},]]
	[22949] = {
		--name = "Gathios the Shatterer",
		name = "Illidari Council",
		encounterID = 608,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			--Black Temple Council boss.
			[31098] = "Leggings of the Forgotten Conqueror",
			[31100] = "Leggings of the Forgotten Protector",
			[31099] = "Leggings of the Forgotten Vanquisher",
		},
	},
	[22950] = {
		--name = "High Nethermancer Zerevor",
		name = "Illidari Council",
		encounterID = 608,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			--Black Temple Council boss.
			[32331] = "Cloak of the Illidari Council",
			[32519] = "Belt of Divine Guidance",
			[32518] = "Veil of Turning Leaves",
			[32376] = "Forest Prowler's Helm",
			[32373] = "Helm of the Illidari Shatterer",
			[32505] = "Madness of the Betrayer",
		},
	},
	[22951] = {
		--name = "Lady Malande",
		name = "Illidari Council",
		encounterID = 608,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			--Black Temple Council boss.
			[31098] = "Leggings of the Forgotten Conqueror",
			[31100] = "Leggings of the Forgotten Protector",
			[31099] = "Leggings of the Forgotten Vanquisher",
		},
	},
	[22952] = {
		--name = "Veras Darkshadow",
		name = "Illidari Council",
		encounterID = 608,
		instanceID = 564,
		hp = 0,
		type = "Humanoid",
		loot = {
			--Black Temple Council boss.
			[31098] = "Leggings of the Forgotten Conqueror",
			[31100] = "Leggings of the Forgotten Protector",
			[31099] = "Leggings of the Forgotten Vanquisher",
		},
	},
	--[[[0] = { --Not an NPC, handle these types of encounters later.
		name = "Reliquary of the Lost",
		encounterID = 0,
		instanceID = 564,
		hp = 0,
		type = "",
		loot = {
			[32353] = "Gloves of Unfailing Faith",
			[32351] = "Elunite Empowered Bracers",
			[32347] = "Grips of Damnation",
			[32352] = "Naturewarden's Treads",
			[32517] = "The Wavemender's Mantle",
			[32346] = "Boneweave Girdle",
			[32354] = "Crown of Empowered Fate",
			[32345] = "Dreadboots of the Legion",
			[32349] = "Translucent Spellthread Necklace",
			[32362] = "Pendant of Titans",
			[32350] = "Touch of Inspiration",
			[32332] = "Torch of the Damned",
			[32363] = "Naaru-Blessed Life Rod",
		},
	},]]
	[23418] = {
		name = "Essence of Suffering",
		encounterID = 0,
		instanceID = 564,
		hp = 0,
		type = "",
		loot = {
 			--Part one of the Reliquary of the Lost encounter.
		},
	},
	[23419] = {
		name = "Essence of Desire",
		encounterID = 0,
		instanceID = 564,
		hp = 0,
		type = "",
		loot = {
 			--Part two of the Reliquary of the Lost encounter.
		},
	},
	[23420] = {
		name = "Essence of Anger",
		encounterID = 0,
		instanceID = 564,
		hp = 0,
		type = "",
		loot = {
 			--Part three of the Reliquary of the Lost encounter, drops the loot?
 			[32353] = "Gloves of Unfailing Faith",
			[32351] = "Elunite Empowered Bracers",
			[32347] = "Grips of Damnation",
			[32352] = "Naturewarden's Treads",
			[32517] = "The Wavemender's Mantle",
			[32346] = "Boneweave Girdle",
			[32354] = "Crown of Empowered Fate",
			[32345] = "Dreadboots of the Legion",
			[32349] = "Translucent Spellthread Necklace",
			[32362] = "Pendant of Titans",
			[32350] = "Touch of Inspiration",
			[32332] = "Torch of the Damned",
			[32363] = "Naaru-Blessed Life Rod",
		},
	},
	--[[[0] = { --BT trash.
			[32590] = "Nethervoid Cloak",
			[34012] = "Shroud of the Final Stand",
			[32609] = "Boots of the Divine Light",
			[32593] = "Treads of the Den Mother",
			[32592] = "Chestguard of Relentless Storms",
			[32608] = "Pillager's Gauntlets",
			[32606] = "Girdle of the Lightbearer",
			[32591] = "Choker of Serrated Blades",
			[32589] = "Hellfire-Encased Pendant",
			[32526] = "Band of Devastation",
			[32528] = "Blessed Band of Karabor",
			[32527] = "Ring of Ancient Knowledge",
			[34009] = "Hammer of Judgement",
			[32943] = "Swiftsteel Bludgeon",
			[34011] = "Illidari Runeshield",
			[32228] = "Empyrean Sapphire",
			[32231] = "Pyrestone",
			[32229] = "Lionseye",
			[32249] = "Seaspray Emerald",
			[32230] = "Shadowsong Amethyst",
			[32227] = "Crimson Spinel",
			[32428] = "Heart of Darkness",
			[32897] = "Mark of the Illidari",

			--Patterns.
			[32738] = "Plans: Dawnsteel Bracers",
			[32739] = "Plans: Dawnsteel Shoulders",
			[32736] = "Plans: Swiftsteel Bracers",
			[32737] = "Plans: Swiftsteel Shoulders",
			[32748] = "Pattern: Bindings of Lightning Reflexes",
			[32744] = "Pattern: Bracers of Renewed Life",
			[32750] = "Pattern: Living Earth Bindings",
			[32751] = "Pattern: Living Earth Shoulders",
			[32749] = "Pattern: Shoulders of Lightning Reflexes",
			[32745] = "Pattern: Shoulderpads of Renewed Life",
			[32746] = "Pattern: Swiftstrike Bracers",
			[32747] = "Pattern: Swiftstrike Shoulders",
			[32754] = "Pattern: Bracers of Nimble Thought",
			[32755] = "Pattern: Mantle of Nimble Thought",
			[32753] = "Pattern: Swiftheal Mantle",
			[32752] = "Pattern: Swiftheal Wraps",
	--},]]
	--Zul'Aman.
	[23574] = {
		name = "Akil'zon <Eagle Avatar>",
		encounterID = 0,
		instanceID = 568,
		hp = 0,
		type = "Humanoid",
		loot = {
			[33286] = "Mojo-mender's Mask",
			[33215] = "Bloodstained Elven Battlevest",
			[33216] = "Chestguard of Hidden Purpose",
			[33281] = "Brooch of Nature's Mercy",
			[33293] = "Signet of Ancient Magics",
			[33214] = "Akil'zon's Talonblade",
			[33283] = "Amani Punisher",
			[33590] = "Cloak of Fiends",
			--Timed box 1.
			[33497] = "Mana Attuned Band",
			[33500] = "Signet of Eternal Life",
			[33496] = "Signet of Primal Wrath",
			[33499] = "Signet of the Last Defender",
			[33498] = "Signet of the Quiet Forest",
		},
	},
	[23576] = {
		name = "Nalorakk <Bear Avatar>",
		encounterID = 0,
		instanceID = 568,
		hp = 0,
		type = "Humanoid",
		loot = {
			[33203] = "Robes of Heavenly Purpose",
			[33285] = "Fury of the Ursine",
			[33211] = "Bladeangel's Money Belt",
			[33206] = "Pauldrons of Primal Fury",
			[33327] = "Mask of Introspection",
			[33191] = "Jungle Stompers",
			[33640] = "Fury",
			--Timed box 2.
			[33495] = "Rage",
			[33493] = "Umbral Shiv",
			[33492] = "Trollbane",
			[33490] = "Staff of Dark Mending",
			[33494] = "Amani Divining Staff",
			[33491] = "Tuskbreaker",
		},
	},
	[23578] = {
		name = "Jan'alai <Dragonhawk Avatar>",
		encounterID = 0,
		instanceID = 568,
		hp = 0,
		type = "Humanoid",
		loot = {
			[33357] = "Footpads of Madness",
			[33356] = "Helm of Natural Regeneration",
			[33329] = "Shadowtooth Trollskin Cuirass",
			[33328] = "Arrow-fall Chestguard",
			[33354] = "Wub's Cursed Hexblade",
			[33326] = "Bulwark of the Amani Empire",
			[33332] = "Enamelled Disc of Mojo",
			--Timed box 3.
			[33591] = "Shadowcaster's Drape",
			[33489] = "Mantle of Ill Intent",
			[33480] = "Cord of Braided Troll Hair",
			[33483] = "Life-step Belt",
			[33971] = "Elunite Imbued Leggings",
			[33805] = "Shadowhunter's Treads",
			[33481] = "Pauldrons of Stone Resolve",
		},
	},
	[23577] = {
		name = "Halazzi <Lynx Avatar>",
		encounterID = 0,
		instanceID = 568,
		hp = 1185000,
		type = "Humanoid",
		loot = {
			[33317] = "Robe of Departed Spirits",
			[33300] = "Shoulderpads of Dancing Blades",
			[33322] = "Shimmer-pelt Vest",
			[33533] = "Avalanche Leggings",
			[33299] = "Spaulders of the Advocate",
			[33303] = "Skullshatter Warboots",
			[33297] = "The Savage's Choker",
			--Timed box 4.
			[33809] = "Amani War Bear",
		},
	},
	[24239] = {
		name = "Hex Lord Malacrass",
		encounterID = 0,
		instanceID = 568,
		hp = 0,
		type = "Humanoid",
		loot = {
			[33592] = "Cloak of Ancient Rituals",
			[33453] = "Hood of Hexing",
			[33463] = "Hood of the Third Eye",
			[33432] = "Coif of the Jungle Stalker",
			[33464] = "Hex Lord's Voodoo Pauldrons",
			[33421] = "Battleworn Tuskguard",
			[33446] = "Girdle of Stromgarde's Hope",
			[33829] = "Hex Shrunken Head",
			[34029] = "Tiny Voodoo Mask",
			[33828] = "Tome of Diabolic Remedy",
			[33389] = "Dagger of Bad Mojo",
			[33298] = "Prowler's Strikeblade",
			[33388] = "Heartless",
			[33465] = "Staff of Primal Fury",
		},
	},
	[23863] = {
		name = "Zul'jin",
		encounterID = 0,
		instanceID = 568,
		hp = 0,
		type = "Humanoid",
		loot = {
			[33471] = "Two-toed Sandals",
			[33479] = "Grimgrin Faceguard",
			[33469] = "Hauberk of the Empire's Champion",
			[33473] = "Chestguard of the Warlord",
			[33466] = "Loop of Cursed Bones",
			[33830] = "Ancient Aqir Artifact",
			[33831] = "Berserker's Call",
			[33307] = "Formula: Enchant Weapon - Executioner",
			[33467] = "Blade of Twisted Visions",
			[33478] = "Jin'rohk, The Great Apocalypse",
			[33476] = "Cleaver of the Unforgiving",
			[33468] = "Dark Blessing",
			[33474] = "Ancient Amani Longbow",
			[33102] = "Blood of Zul'jin",
		},
	},
	--[0] = { --ZA trash.
		--Only a few green items.
		--[[[33993] = "Mojo",
		[33865] = "Amani Hex Stick",
		[33930] = "Amani Charm of the Bloodletter",
		[33932] = "Amani Charm of the Witch Doctor",
		[33931] = "Amani Charm of Mighty Mojo",
		[33933] = "Amani Charm of the Raging Defender",]]
	--},
	--Sunwell Plateau.
	[24850] = {
		name = "Kalecgos",
		encounterID = 724,
		instanceID = 580,
		hp = 0,
		type = "Humanoid",
		loot = {
			[34170] = "Pantaloons of Calming Strife",
			[34386] = "Pantaloons of Growing Strife",
			[34169] = "Breeches of Natural Aggression",
			[34384] = "Breeches of Natural Splendor",
			[34168] = "Starstalker Legguards",
			[34167] = "Legplates of the Holy Juggernaut",
			[34382] = "Judicator's Legguards",
			[34166] = "Band of Lucent Beams",
			[34165] = "Fang of Kalecgos",
			[34164] = "Dragonscale-Encrusted Longblade",
			[34848] = "Bracers of the Forgotten Conqueror",
			[34851] = "Bracers of the Forgotten Protector",
			[34852] = "Bracers of the Forgotten Vanquisher",
		},
	},
	[24892] = {
		name = "Sathrovarr the Corruptor",
		encounterID = 724,
		instanceID = 580,
		hp = 0,
		type = "Humanoid",
		loot = {
			--Together with Kalecgos fight, does this actually drop any of the loot?
			--[[[34170] = "Pantaloons of Calming Strife",
			[34386] = "Pantaloons of Growing Strife",
			[34169] = "Breeches of Natural Aggression",
			[34384] = "Breeches of Natural Splendor",
			[34168] = "Starstalker Legguards",
			[34167] = "Legplates of the Holy Juggernaut",
			[34382] = "Judicator's Legguards",
			[34166] = "Band of Lucent Beams",
			[34165] = "Fang of Kalecgos",
			[34164] = "Dragonscale-Encrusted Longblade",
			[34848] = "Bracers of the Forgotten Conqueror",
			[34851] = "Bracers of the Forgotten Protector",
			[34852] = "Bracers of the Forgotten Vanquisher",]]
		},
	},
	[24882] = {
		name = "Brutallus",
		encounterID = 725,
		instanceID = 580,
		hp = 0,
		type = "Humanoid",
		loot = {
			[34181] = "Leggings of Calamity",
			[34180] = "Felfury Legplates",
			[34381] = "Felstrength Legplates",
			[34178] = "Collar of the Pit Lord",
			[34177] = "Clutch of Demise",
			[34179] = "Heart of the Pit",
			[34176] = "Reign of Misery",
			[34853] = "Belt of the Forgotten Conqueror",
			[34854] = "Belt of the Forgotten Protector",
			[34855] = "Belt of the Forgotten Vanquisher",
		},
	},
	[25038] = {
		name = "Felmyst",
		encounterID = 726,
		instanceID = 580,
		hp = 0,
		type = "Undead",
		loot = {
			[34352] = "Borderland Fortress Grips",
			[34188] = "Leggings of the Immortal Night",
			[34385] = "Leggings of the Immortal Beast",
			[34186] = "Chain Links of the Tumultuous Storm",
			[34383] = "Kilt of Spiritual Reconstruction",
			[34184] = "Brooch of the Highborne",
			[34185] = "Sword Breaker's Bulwark",
			[34182] = "Grand Magister's Staff of Torrents",
			[34856] = "Boots of the Forgotten Conqueror",
			[34857] = "Boots of the Forgotten Protector",
			[34858] = "Boots of the Forgotten Vanquisher",
		},
	},
	[25741] = {
		name = "M'uru",
		encounterID = 728,
		instanceID = 580,
		hp = 0,
		type = "",
		loot = {
			[34232] = "Fel Conquerer Raiments",
			[34233] = "Robes of Faltered Light",
			[34399] = "Robes of Ghostly Hatred",
			[34212] = "Sunglow Vest",
			[34398] = "Utopian Tunic of Elune",
			[34211] = "Harness of Carnal Instinct",
			[34397] = "Bladed Chaos Tunic",
			[34234] = "Shadowed Gauntlets of Paroxysm",
			[34408] = "Gloves of the Forest Drifter",
			[34229] = "Garments of Serene Shores",
			[34396] = "Garments of Crashing Shores",
			[34228] = "Vicious Hawkstrider Hauberk",
			[34215] = "Warharness of Reckless Fury",
			[34394] = "Breastplate of Agony's Aversion",
			[34240] = "Gauntlets of the Soothed Soul",
			[34216] = "Heroic Judicator's Chestguard",
			[34395] = "Noble Judicator's Chestguard",
			[34213] = "Ring of Hardened Resolve",
			[34230] = "Ring of Omnipotence",
			[35282] = "Sin'dorei Band of Dominance",
			[35283] = "Sin'dorei Band of Salvation",
			[35284] = "Sin'dorei Band of Triumph",
			[34427] = "Blackened Naaru Sliver",
			[34430] = "Glimmering Naaru Sliver",
			[34429] = "Shifting Naaru Sliver",
			[34428] = "Steely Naaru Sliver",
			[34214] = "Muramasa",
			[34231] = "Aegis of Angelic Fortune",
		},
	},
	--[[[25840] = {
		name = "Entropiu",
		encounterID = 728,
		instanceID = 580,
		hp = 0,
		type = "Demon",
		loot = {
			--Phase 2 of M'uru fight, which boss form drops the loot?
			--Probably don't need to include this npc at all.
		},
	},]]
	[25315] = {
		name = "Kil'jaeden",
		encounterID = 729,
		instanceID = 580,
		hp = 0,
		type = "Demon",
		loot = {
			[34241] = "Cloak of Unforgivable Sin",
			[34242] = "Tattered Cape of Antonidas",
			[34339] = "Cowl of Light's Purity",
			[34405] = "Helm of Arcane Purity",
			[34340] = "Dark Conjuror's Collar",
			[34342] = "Handguards of the Dawn",
			[34406] = "Gloves of Tyri's Power",
			[34344] = "Handguards of Defiled Worlds",
			[34244] = "Duplicitous Guise",
			[34404] = "Mask of the Fury Hunter",
			[34245] = "Cover of Ursol the Wise",
			[34403] = "Cover of Ursoc the Mighty",
			[34333] = "Coif of Alleria",
			[34332] = "Cowl of Gul'dan",
			[34402] = "Shroud of Chieftain Ner'zhul",
			[34343] = "Thalassian Ranger Gauntlets",
			[34243] = "Helm of Burning Righteousness",
			[34401] = "Helm of Uther's Resolve",
			[34345] = "Crown of Anasterian",
			[34400] = "Crown of Dath'Remar",
			[34341] = "Borderland Paingrips",
			[34334] = "Thori'dal, the Stars' Fury",
			[34329] = "Crux of the Apocalypse",
			[34247] = "Apolyon, the Soul-Render",
			[34335] = "Hammer of Sanctification",
			[34331] = "Hand of the Deceiver",
			[34336] = "Sunflare",
			[34337] = "Golden Staff of the Sin'dorei",
		},
	},
	--[[[0] = { --Not an NPC, handle these types of encounters later.
		name = "Eredar Twins",
		encounterID = 727,
		instanceID = 580,
		hp = 0,
		type = "",
		loot = {
			[34205] = "Shroud of Redeemed Souls",
			[34190] = "Crimson Paragon's Cover",
			[34210] = "Amice of the Convoker",
			[34202] = "Shawl of Wonderment",
			[34393] = "Shoulderpads of Knowledge's Pursuit",
			[34209] = "Spaulders of Reclamation",
			[34391] = "Spaulders of Devastation",
			[34195] = "Shoulderpads of Vehemence",
			[34392] = "Demontooth Shoulderpads",
			[34194] = "Mantle of the Golden Forest",
			[34208] = "Equilibrium Epaulets",
			[34390] = "Erupting Epaulets",
			[34192] = "Pauldrons of Perseverance",
			[34388] = "Pauldrons of Berserking",
			[34193] = "Spaulders of the Thalassian Savior",
			[34389] = "Spaulders of the Thalassian Defender",
			[35290] = "Sin'dorei Pendant of Conquest",
			[35291] = "Sin'dorei Pendant of Salvation",
			[35292] = "Sin'dorei Pendant of Triumph",
			[34204] = "Amulet of Unfettered Magics",
			[34189] = "Band of Ruinous Delight",
			[34206] = "Book of Highborne Hymns",
			[34197] = "Shiv of Exsanguination",
			[34199] = "Archon's Gavel",
			[34203] = "Grip of Mannoroth",
			[34198] = "Stanchion of Primal Instinct",
			[34196] = "Golden Bow of Quel'Thalas",
		},
	},]]
	[25166] = {
		name = "Grand Warlock Alythess",
		encounterID = 727,
		instanceID = 580,
		hp = 0,
		type = "Demon",
		loot = {
			--Part of Erodar Twins.
			[34205] = "Shroud of Redeemed Souls",
			[34190] = "Crimson Paragon's Cover",
			[34210] = "Amice of the Convoker",
			[34202] = "Shawl of Wonderment",
			[34393] = "Shoulderpads of Knowledge's Pursuit",
			[34209] = "Spaulders of Reclamation",
			[34391] = "Spaulders of Devastation",
			[34195] = "Shoulderpads of Vehemence",
			[34392] = "Demontooth Shoulderpads",
			[34194] = "Mantle of the Golden Forest",
			[34208] = "Equilibrium Epaulets",
			[34390] = "Erupting Epaulets",
			[34192] = "Pauldrons of Perseverance",
			[34388] = "Pauldrons of Berserking",
			[34193] = "Spaulders of the Thalassian Savior",
			[34389] = "Spaulders of the Thalassian Defender",
			[35290] = "Sin'dorei Pendant of Conquest",
			[35291] = "Sin'dorei Pendant of Salvation",
			[35292] = "Sin'dorei Pendant of Triumph",
			[34204] = "Amulet of Unfettered Magics",
			[34189] = "Band of Ruinous Delight",
			[34206] = "Book of Highborne Hymns",
			[34197] = "Shiv of Exsanguination",
			[34199] = "Archon's Gavel",
			[34203] = "Grip of Mannoroth",
			[34198] = "Stanchion of Primal Instinct",
			[34196] = "Golden Bow of Quel'Thalas",
			[34848] = "Bracers of the Forgotten Conqueror", --The twins can drop any of the tier.
			[34851] = "Bracers of the Forgotten Protector",
			[34852] = "Bracers of the Forgotten Vanquisher",
			[34856] = "Boots of the Forgotten Conqueror",
			[34857] = "Boots of the Forgotten Protector",
			[34858] = "Boots of the Forgotten Vanquisher",
			[34853] = "Belt of the Forgotten Conqueror",
			[34854] = "Belt of the Forgotten Protector",
			[34855] = "Belt of the Forgotten Vanquisher",
		},
	},
	[25165] = {
		name = "Lady Sacrolash",
		encounterID = 727,
		instanceID = 580,
		hp = 0,
		type = "Demon",
		loot = {
			--Part of Erodar Twins.
			[34205] = "Shroud of Redeemed Souls",
			[34190] = "Crimson Paragon's Cover",
			[34210] = "Amice of the Convoker",
			[34202] = "Shawl of Wonderment",
			[34393] = "Shoulderpads of Knowledge's Pursuit",
			[34209] = "Spaulders of Reclamation",
			[34391] = "Spaulders of Devastation",
			[34195] = "Shoulderpads of Vehemence",
			[34392] = "Demontooth Shoulderpads",
			[34194] = "Mantle of the Golden Forest",
			[34208] = "Equilibrium Epaulets",
			[34390] = "Erupting Epaulets",
			[34192] = "Pauldrons of Perseverance",
			[34388] = "Pauldrons of Berserking",
			[34193] = "Spaulders of the Thalassian Savior",
			[34389] = "Spaulders of the Thalassian Defender",
			[35290] = "Sin'dorei Pendant of Conquest",
			[35291] = "Sin'dorei Pendant of Salvation",
			[35292] = "Sin'dorei Pendant of Triumph",
			[34204] = "Amulet of Unfettered Magics",
			[34189] = "Band of Ruinous Delight",
			[34206] = "Book of Highborne Hymns",
			[34197] = "Shiv of Exsanguination",
			[34199] = "Archon's Gavel",
			[34203] = "Grip of Mannoroth",
			[34198] = "Stanchion of Primal Instinct",
			[34196] = "Golden Bow of Quel'Thalas",
			[34848] = "Bracers of the Forgotten Conqueror",
			[34851] = "Bracers of the Forgotten Protector",
			[34852] = "Bracers of the Forgotten Vanquisher",
			[34856] = "Boots of the Forgotten Conqueror",
			[34857] = "Boots of the Forgotten Protector",
			[34858] = "Boots of the Forgotten Vanquisher",
			[34853] = "Belt of the Forgotten Conqueror",
			[34854] = "Belt of the Forgotten Protector",
			[34855] = "Belt of the Forgotten Vanquisher",
		},
	},
	--[[[0] = { --Sunwell trash.
			[34351] = "Tranquil Majesty Wraps",
			[34407] = "Tranquil Moonlight Wraps",
			[34350] = "Gauntlets of the Ancient Shadowmoon",
			[34409] = "Gauntlets of the Ancient Frostwolf",
			[35733] = "Ring of Harmonic Beauty",
			[34183] = "Shivering Felspine",
			[34346] = "Mounting Vengeance",
			[34349] = "Blade of Life's Inevitability",
			[34348] = "Wand of Cleansing Light",
			[34347] = "Wand of the Demonsoul",
			[35273] = "Study of Advanced Smelting",
			[34664] = "Sunmote",
			[32228] = "Empyrean Sapphire",
			[32231] = "Pyrestone",
			[32229] = "Lionseye",
			[32249] = "Seaspray Emerald",
			[32230] = "Shadowsong Amethyst",
			[32227] = "Crimson Spinel",
			[35208] = "Plans: Sunblessed Gauntlets",
			[35210] = "Plans: Sunblessed Breastplate",
			[35209] = "Plans: Hard Khorium Battlefists",
			[35211] = "Plans: Hard Khorium Battleplate",
                
                --Patterns.
			[35212] = "Pattern: Leather Gauntlets of the Sun",
			[35216] = "Pattern: Leather Chestguard of the Sun",
			[35213] = "Pattern: Fletcher's Gloves of the Phoenix",
			[35217] = "Pattern: Embrace of the Phoenix",
			[35214] = "Pattern: Gloves of Immortal Dusk",
			[35218] = "Pattern: Carapace of Sun and Shadow",
			[35215] = "Pattern: Sun-Drenched Scale Gloves",
			[35219] = "Pattern: Sun-Drenched Scale Chestguard",
			[35204] = "Pattern: Sunfire Handwraps",
			[35206] = "Pattern: Sunfire Robe",
			[35205] = "Pattern: Hands of Eternal Light",
			[35207] = "Pattern: Robe of Eternal Light",
			[35198] = "Design: Loop of Forged Power",
			[35201] = "Design: Pendant of Sunfire",
			[35199] = "Design: Ring of Flowing Life",
			[35202] = "Design: Amulet of Flowing Life",
			[35200] = "Design: Hard Khorium Band",
			[35203] = "Design: Hard Khorium Choker",
			[35186] = "Schematic: Annihilator Holo-Gogs",
			[35187] = "Schematic: Justicebringer 3000 Specs",
			[35189] = "Schematic: Powerheal 9000 Lens",
			[35190] = "Schematic: Hyper-Magnified Moon Specs",
			[35191] = "Schematic: Wonderheal XT68 Shades",
			[35192] = "Schematic: Primal-Attuned Goggles",
			[35193] = "Schematic: Lightning Etched Specs",
			[35194] = "Schematic: Surestrike Goggles v3.0",
			[35195] = "Schematic: Mayhem Projection Goggles",
			[35196] = "Schematic: Hard Khorium Goggles",
			[35197] = "Schematic: Quad Deathblow X44 Goggles",
	--},]]
}

NRC.ignoredLoot = {
	--TBC.
	[29434] = "Badge of Justice",
	--Wrath
	[40753] = "Emblem of Valor",
	[47241] = "Emblem of Triumph",
	[40752] = "Emblem of Heroism",
	[45624] = "Emblem of Conquest",
	[49426] = "Emblem of Frost",
};

NRC.distractingShot = {
	--Id = threat.
	[20736] = 110,
	[14274] = 160,
	[15629] = 250,
	[15630] = 350,
	[15631] = 465,
	[15632] = 600,
	[27020] = 900,
};

NRC.resurrectionSpells = {
	[2006] = {
		name = "Resurrection", --Priest Rank 1.
		icon = 135955,
	},
	[2010] = {
		name = "Resurrection", --Priest Rank 2.
		icon = 135955,
	},
	[10880] = {
		name = "Resurrection", --Priest Rank 3.
		icon = 135955,
	},
	[10881] = {
		name = "Resurrection", --Priest Rank 4.
		icon = 135955,
	},
	[20770] = {
		name = "Resurrection", --Priest Rank 5.
		icon = 135955,
	},
	[25435] = {
		name = "Resurrection", --Priest Rank 6.
		icon = 135955,
	},
	[2008] = {
		name = "Ancestral Spirit", --Shaman rank 1.
		icon = 136077,
	},
	[20609] = {
		name = "Ancestral Spirit", --Shaman rank 2.
		icon = 136077,
	},
	[20610] = {
		name = "Ancestral Spirit", --Shaman rank 3.
		icon = 136077,
	},
	[20776] = {
		name = "Ancestral Spirit", --Shaman rank 4.
		icon = 136077,
	},
	[20777] = {
		name = "Ancestral Spirit", --Shaman rank 5.
		icon = 136077,
	},
	[25590] = {
		name = "Ancestral Spirit", --Shaman rank 6.
		icon = 136077,
	},
	[7328] = {
		name = "Redemption", --Paladin rank 1.
		icon = 135955,
	},
	[10322] = {
		name = "Redemption", --Paladin rank 2.
		icon = 135955,
	},
	[10324] = {
		name = "Redemption", --Paladin rank 3.
		icon = 135955,
	},
	[20772] = {
		name = "Redemption", --Paladin rank 4.
		icon = 135955,
	},
	[20773] = {
		name = "Redemption", --Paladin rank 5.
		icon = 135955,
	},
	[20484] = {
		name = "Rebirth", --Rank 1.
		icon = 136080,
	},
	[20739] = {
		name = "Rebirth", --Rank 2.
		icon = 136080,
	},
	[20742] = {
		name = "Rebirth", --Rank 3.
		icon = 136080,
	},
	[20747] = {
		name = "Rebirth", --Rank 4.
		icon = 136080,
	},
	[20748] = {
		name = "Rebirth", --Rank 5.
		icon = 136080,
	},
	[26994] = {
		name = "Rebirth", --Rank 6.
		icon = 136080,
	},
};

NRC.magePortals = {
	[11417] = {
		name = "Portal: Orgrimmar",
		icon = 135744,
	},
	[10059] = {
		name = "Portal: Stormwind",
		icon = 135748,
	},
	[49361] = {
		name = "Portal: Stonard",
		icon = 135747,
	},
	[49360] = {
		name = "Portal: Theramore",
		icon = 135749,
	},
	[32266] = {
		name = "Portal: Exodar",
		icon = 135742,
	},
	[32267] = {
		name = "Portal: Silvermoon",
		icon = 135746,
	},
	[11420] = {
		name = "Portal: Thunder Bluff",
		icon = 135750,
	},
	[11419] = {
		name = "Portal: Darnassus",
		icon = 135741,
	},
	[11416] = {
		name = "Portal: Ironforge",
		icon = 135743,
	},
	[11418] = {
		name = "Portal: Undercity",
		icon = 135751,
	},
	[33691] = { --Alliance.
		name = "Portal: Shattrath",
		icon = 135745,
	},
	[35717] = { --Horde.
		name = "Portal: Shattrath",
		icon = 135745,
	},
};

NRC.healthstones = {
	[27235] = {
		name = "Healthstone (0/2)",
		icon = 135230,
		spellName = "Healthstone",
	},
	[27236] = {
		name = "Healthstone (1/2)",
		icon = 135230,
		spellName = "Healthstone",
	},
	[27237] = {
		name = "Healthstone (2/2)",
		icon = 135230,
		spellName = "Healthstone",
	},
};
		
NRC.dpsPotions = {
	[28508] = {
		name = "Destruction Potion",
		icon = 134729,
	},
	[28507] = {
		name = "Haste Potion",
		icon = 134730,
	},
	[28515] = {
		name = "Ironshield Potion",
		icon = 134758,
	},
	[28506] = {
		name = "Heroic Potion",
		icon = 134728,
	},
	[28494] = {
		name = "Insane Strength Potion",
		icon = 134731,
	},
	[28492] = {
		name = "Sneaking Potion",
		icon = 134733,
	},
	[11392] = {
		name = "Invisibility Potion",
		icon = 134805,
	},
	[3680] = {
		name = "Lesser Invisibility Potion",
		icon = 134798,
	},
};

NRC.manaPotions = {
	[17531] = {
		name = "Major Mana Potion",
		icon = 134856,
	},
	[28499] = {
		name = "Super Mana Potion",
		icon = 134762,
	},
	[22729] = {
		name = "Major Rejuvenation Potion",
		icon = 134827,
	},
	[28517] = {
		name = "Super Rejuvenation Potion",
		icon = 134759,
	},
	[28504] = {
		name = "Major Dreamless Sleep Potion",
		icon = 134764,
	},
	[38908] = {
		name = "Fel Regeneration Potion",
		icon = 134766,
	},
	[16666] = {
		name = "Demonic Rune",
		icon = 134417,
	},
	[27869] = {
		name = "Dark Rune",
		icon = 136192,
	},
};

NRC.healingPotions = {
	[17534] = {
		name = "Major Healing Potion",
		icon = 134834,
	},
	[28495] = {
		name = "Super Healing Potion",
		icon = 134756,
	},
	[22729] = {
		name = "Major Rejuvenation Potion",
		icon = 134827,
	},
	[28517] = {
		name = "Super Rejuvenation Potion",
		icon = 134759,
	},
	[28504] = {
		name = "Major Dreamless Sleep Potion",
		icon = 134764,
	},
	[38908] = {
		name = "Fel Regeneration Potion",
		icon = 134766,
	},
};

NRC.tempEnchants = {
	--Mapped to enchantID not spellID.
	[2713] = {
		name = "Adamantite Sharpening Stone",
		icon = 135254,
		desc = "Increase sharp weapon damage by 12 and add 14 melee critical strike rating for 1 hour.",
		maxRank = true,
	},
	[2955] = {
		name = "Adamantite Weightstone",
		icon = 135261,
		desc = "Increase blunt weapon damage by 12 and add 14 critical hit rating for 1 hour.",
		maxRank = true,
	},
	[2640] = {
		name = "Anesthetic Poison",
		icon = 136093,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 134 to 172 Nature damage, but causes no additional threat.",
		maxRank = true,
	},
	[3265] = {
		name = "Blessed Weapon Coating",
		icon = 134723,
		desc = "Chance to regain 165 mana on each spell cast. Only functions on the Isle of Quel'Danas.",
		maxRank = true,
	},
	[2685] = {
		name = "Blessed Wizard Oil",
		icon = 134806,
		desc = "Increases spell damage against undead by up to 60.",
		maxRank = true,
	},
	[2629] = {
		name = "Brilliant Mana Oil",
		icon = 134722,
		desc = "Restores 12 mana to the caster every 5 seconds and increases the effect of healing spells by up to 25.",
		maxRank = true,
	},
	[2628] = {
		name = "Brilliant Wizard Oil",
		icon = 134727,
		desc = "Increases spell damage by up to 36 and increases spell critical strike rating by 14.",
		maxRank = true,
	},
	[13] = {
		name = "Coarse Sharpening Stone",
		icon = 135249,
		desc = "Increase sharp weapon damage by 3 for 1 hour.",
	},
	[20] = {
		name = "Coarse Weightstone",
		icon = 135256,
		desc = "Increase the damage of a blunt weapon by 3 for 1 hour.",
	},
	[2684] = {
		name = "Consecrated Sharpening Stone",
		icon = 135249,
		desc = "Increases attack power against undead by 100.",
		maxRank = true,
	},
	[22] = {
		name = "Crippling Poison",
		icon = 132274,
		desc = "Each strike has a 30% chance of poisoning the enemy, slowing their movement speed by 50% for 12 sec.",
	},
	[603] = {
		name = "Crippling Poison II",
		icon = 132274,
		desc = "Each strike has a 30% chance of poisoning the enemy, slowing their movement speed by 70% for 12 sec.",
		maxRank = true,
	},
	[7] = {
		name = "Deadly Poison",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 36 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
	},
	[8] = {
		name = "Deadly Poison II",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 52 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
	},
	[626] = {
		name = "Deadly Poison III",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 80 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
	},
	[627] = {
		name = "Deadly Poison IV",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 108 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
	},
	[2630] = {
		name = "Deadly Poison V",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 136 Nature damage over 12 sec.  Stacks up to 5 times on a single target.",
	},
	[2642] = {
		name = "Deadly Poison VI",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 144 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
	},
	[2643] = {
		name = "Deadly Poison VII",
		icon = 132290,
		desc = "Each strike has a 30% chance of poisoning the enemy for 180 Nature damage over 12 sec. Stacks up to 5 times on a single target.",
		maxRank = true,
	},
	[1643] = {
		name = "Dense Sharpening Stone",
		icon = 135252,
		desc = "Increase sharp weapon damage by 8 for 1 hour.",
	},
	[1703] = {
		name = "Dense Weightstone",
		icon = 135259,
		desc = "Increase the damage of a blunt weapon by 8 for 1 hour.",
	},
	[2506] = {
		name = "Elemental Sharpening Stone",
		icon = 135228,
		desc = "Increase the critical strike rating on a melee weapon by 28 for 1 hour.",
		maxRank = true,
	},
	[2712] = {
		name = "Fel Sharpening Stone",
		icon = 135253,
		desc = "Increase sharp weapon damage by 12 for 1 hour.",
	},
	[2954] = {
		name = "Fel Weightstone",
		icon = 135260,
		desc = "Increase blunt weapon damage by 12 for 1 hour.",
	},
	[26] = {
		name = "Frost Oil",
		icon = 134800,
		desc = "10% chance of casting Frostbolt at the opponent when it hits.",
	},
	--[[[2791] = {
		name = "Greater Rune of Warding",
		icon = 134423,
		desc = "Enchant chest armor so it has a 25% chance per hit of giving you 400 points of physical damage absorption. 90 sec cooldown.",
		maxRank = true,
	},
	[2720] = {
		name = "Greater Ward of Shielding",
		icon = 134426,
		desc = "Applies the Greater Ward of Shielding to your shield.  This ward absorbs up to 4000 points of damage before it fails.",
		maxRank = true,
	},]]
	[14] = {
		name = "Heavy Sharpening Stone",
		icon = 135250,
		desc = "Increase sharp weapon damage by 4 for 1 hour.",
	},
	[21] = {
		name = "Heavy Weightstone",
		icon = 135257,
		desc = "Increase the damage of a blunt weapon by 4 for 1 hour.",
	},
	[323] = {
		name = "Instant Poison",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 19 to 25 Nature damage.",
	},
	[324] = {
		name = "Instant Poison II",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 30 to 38 Nature damage.",
	},
	[325] = {
		name = "Instant Poison III",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 44 to 56 Nature damage.",
	},
	[623] = {
		name = "Instant Poison IV",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 67 to 85 Nature damage.",
	},
	[624] = {
		name = "Instant Poison V",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 92 to 118 Nature damage.",
	},
	[625] = {
		name = "Instant Poison VI",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 112 to 148 Nature damage.",
	},
	[2641] = {
		name = "Instant Poison VII",
		icon = 132273,
		desc = "Each strike has a 20% chance of poisoning the enemy which instantly inflicts 146 to 194 Nature damage.",
		maxRank = true,
	},
	[2625] = {
		name = "Lesser Mana Oil",
		icon = 134879,
		desc = "While applied to target weapon it restores 8 mana to the caster every 5 seconds.",
	},
	--[[[2781] = {
		name = "Lesser Rune of Warding",
		icon = 134424,
		desc = "Enchant chest armor so it has a 25% chance per hit of giving you 200 points of physical damage absorption. 90 sec cooldown.",
	},
	[2719] = {
		name = "Lesser Ward of Shielding",
		icon = 134425,
		desc = "Applies the Lesser Ward of Shielding to your shield.  This ward absorbs up to 1000 points of damage before it fails.",
	},]]
	[2626] = {
		name = "Lesser Wizard Oil",
		icon = 134725,
		desc = "While applied to target weapon it increases spell damage by up to 16.",
	},
	[35] = {
		name = "Mind-numbing Poison",
		icon = 136066,
		desc = "Each strike has a 20% chance of poisoning the enemy, increasing their casting time by 40% for 10 sec.",
	},
	[23] = {
		name = "Mind-numbing Poison II",
		icon = 136066,
		desc = "Each strike has a 20% chance of poisoning the enemy, increasing their casting time by 50% for 12 sec.",
	},
	[643] = {
		name = "Mind-numbing Poison III",
		icon = 136066,
		desc = "Each strike has a 20% chance of poisoning the enemy, increasing their casting time by 60% for 14 sec.",
		maxRank = true,
	},
	[2624] = {
		name = "Minor Mana Oil",
		icon = 134878,
		desc = "While applied to target weapon it restores 4 mana to the caster every 5 seconds.",
	},
	[2623] = {
		name = "Minor Wizard Oil",
		icon = 134711,
		desc = "While applied to target weapon it increases spell damage by up to 8.",
	},
	[3266] = {
		name = "Righteous Weapon Coating",
		icon = 134723,
		desc = "While applied to target weapon, wielder has a chance to gain 300 attack power on every melee or ranged attack for 10 sec. Only functions on the Isle of Quel'Danas.",
		maxRank = true,
	},
	[40] = {
		name = "Rough Sharpening Stone",
		icon = 135248,
		desc = "Increase sharp weapon damage by 2 for 1 hour.",
	},
	[19] = {
		name = "Rough Weightstone",
		icon = 135255,
		desc = "Increase the damage of a blunt weapon by 2 for 1 hour.",
	},
	[25] = {
		name = "Shadow Oil",
		icon = 134803,
		desc = "15% chance of casting Shadow Bolt (Rank 3) at the opponent when it hits.",
	},
	[483] = {
		name = "Solid Sharpening Stone",
		icon = 135251,
		desc = "Increase sharp weapon damage by 6 for 1 hour.",
	},
	[484] = {
		name = "Solid Weightstone",
		icon = 135258,
		desc = "Increase the damage of a blunt weapon by 6 for 1 hour.",
	},
	[2677] = {
		name = "Superior Mana Oil",
		icon = 134723,
		desc = "Restores 14 mana to the caster every 5 seconds.",
		maxRank = true,
	},
	[2678] = {
		name = "Superior Wizard Oil",
		icon = 134767,
		desc = "Increases spell damage by up to 42.",
		maxRank = true,
	},
	[2627] = {
		name = "Wizard Oil",
		icon = 134726,
		desc = "Increases spell damage by up to 24.",
	},
	[703] = {
		name = "Wound Poison",
		icon = 134197,
		desc = "Each strike has a 30% chance of poisoning the enemy, causing 17 Nature damage and reducing all healing effects used on them by 10% for 15 sec.",
	},
	[704] = {
		name = "Wound Poison II",
		icon = 134197,
		desc = "Each strike has a 30% chance of poisoning the enemy, causing 25 Nature damage and reducing all healing effects used on them by 10% for 15 sec.",
	},
	[705] = {
		name = "Wound Poison III",
		icon = 134197,
		desc = "Each strike has a 30% chance of poisoning the enemy, causing 38 Nature damage and reducing all healing effects used on them by 10% for 15 sec.",
	},
	[706] = {
		name = "Wound Poison IV",
		icon = 134197,
		desc = "Each strike has a 30% chance of poisoning the enemy, causing 53 Nature damage and reducing all healing effects used on them by 10% for 15 sec.",
	},
	[2644] = {
		name = "Wound Poison V",
		icon = 134197,
		desc = "Each strike has a 30% chance of poisoning the enemy, causing 65 Nature damage and reducing all healing effects used on them by 10% for 15 sec",
		maxRank = true,
	},
	--Shaman self weapon enchants.
	[15] = {
		name = "Flametongue Weapon 1",
		icon = 135814,
		desc = "Each hit causes 6 to 18 additional Fire damage, based on the speed of the weapon.",
	},
	[4] = {
		name = "Flametongue Weapon 2",
		icon = 135814,
		desc = "Each hit causes 9 to 26 additional Fire damage, based on the speed of the weapon.",
	},
	[3] = {
		name = "Flametongue Weapon 3",
		icon = 135814,
		desc = "Each hit causes 22 to 69 additional Fire damage, based on the speed of the weapon.",
	},
	[523] = {
		name = "Flametongue Weapon 4",
		icon = 135814,
		desc = "Each hit causes 6 to 18 additional Fire damage, based on the speed of the weapon.",
	},
	[1665] = {
		name = "Flametongue Weapon 5",
		icon = 135814,
		desc = "Each hit causes 31 to 95 additional Fire damage, based on the speed of the weapon.",
	},
	[1666] = {
		name = "Flametongue Weapon 6",
		icon = 135814,
		desc = "Each hit causes 40 to 124 additional Fire damage, based on the speed of the weapon.",
	},
	[2634] = {
		name = "Flametongue Weapon 7",
		icon = 135814,
		desc = "Each hit causes 46 to 140 additional Fire damage, based on the speed of the weapon.",
		maxRank = true,
	},
	[2] = {
		name = "Frostbrand Weapon 1",
		icon = 135847,
		desc = "Each hit has a chance of causing 48 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
	},
	[12] = {
		name = "Frostbrand Weapon 2",
		icon = 135847,
		desc = "Each hit has a chance of causing 77 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
	},
	[524] = {
		name = "Frostbrand Weapon 3",
		icon = 135847,
		desc = "Each hit has a chance of causing 124 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
	},
	[1667] = {
		name = "Frostbrand Weapon 4",
		icon = 135847,
		desc = "Each hit has a chance of causing 166 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
	},
	[1668] = {
		name = "Frostbrand Weapon 5",
		icon = 135847,
		desc = "Each hit has a chance of causing 215 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
	},
	[2635] = {
		name = "Frostbrand Weapon 6",
		icon = 135847,
		desc = "Each hit has a chance of causing 246 additional Frost damage and slowing the target's movement speed by 25% for 8 sec.",
		maxRank = true,
	},
	[29] = {
		name = "Rockbiter Weapon 1",
		icon = 136086,
		desc = "Increase weapon damage per second by 2.",
	},
	[6] = {
		name = "Rockbiter Weapon 2",
		icon = 136086,
		desc = "Increase weapon damage per second by 4.",
	},
	[1] = {
		name = "Rockbiter Weapon 3",
		icon = 136086,
		desc = "Increase weapon damage per second by 6.",
	},
	[503] = {
		name = "Rockbiter Weapon 4",
		icon = 136086,
		desc = "Increase weapon damage per second by 9.",
	},
	[1663] = {
		name = "Rockbiter Weapon 5",
		icon = 136086,
		desc = "Increase weapon damage per second by 15.",
	},
	[683] = {
		name = "Rockbiter Weapon 6",
		icon = 136086,
		desc = "Increase weapon damage per second by 28.",
	},
	[1664] = {
		name = "Rockbiter Weapon 7",
		icon = 136086,
		desc = "Increase weapon damage per second by 40.",
	},
	[2632] = {
		name = "Rockbiter Weapon 8",
		icon = 136086,
		desc = "Increase weapon damage per second by 49.",
	},
	[2633] = {
		name = "Rockbiter Weapon 9",
		icon = 136086,
		desc = "Increase weapon damage per second by 62.",
		maxRank = true,
	},
	[283] = {
		name = "Windfury Weapon 1",
		icon = 136018,
		desc = "Each hit has a 20% chance of dealing additional damage equal to two extra attacks with 104 extra attack power.",
	},
	[284] = {
		name = "Windfury Weapon 2",
		icon = 136018,
		desc = "Each hit has a 20% chance of dealing additional damage equal to two extra attacks with 222 extra attack power.",
	},
	[525] = {
		name = "Windfury Weapon 3",
		icon = 136018,
		desc = "Each hit has a 20% chance of dealing additional damage equal to two extra attacks with 316 extra attack power.",
	},
	[1669] = {
		name = "Windfury Weapon 4",
		icon = 136018,
		desc = "Each hit has a 20% chance of dealing additional damage equal to two extra attacks with 433 extra attack power.",
	},
	[2636] = {
		name = "Windfury Weapon 5",
		icon = 136018,
		desc = "Each hit has a 20% chance of dealing additional damage equal to two extra attacks with 475 extra attack power.",
		maxRank = true,
	},
};

--For use with our local talent db, resto and holy works for multiple classes.
NRC.healingSpecs = {
	["Restoration"] = true,
	["Holy"] = true,
	["Discipline"] = true,
};

---These buff tables below are wiped after being loaded locally in RaidStatus.
---They are just loaded here first for expansion seperation reasons.

NRC.int = {
	[1459] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+2 Int",
		rank = 1,
	},
	[1460] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+7 Int",
		rank = 2,
	},
	[1461] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+15 Int",
		rank = 3,
	},
	[10156] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+22 Int",
		rank = 4,
	},
	[10157] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+31 Int",
		rank = 5,
	},
	[27126] = {
		name = "Arcane Intellect",
		icon = 135932,
		desc = "+40 Int",
		rank = 6,
		maxRank = true,
	},
	[23028] = {
		name = "Arcane Brilliance",
		icon = 135869,
		desc = "+31 Int",
		rank = 1,
	},
	[27127] = {
		name = "Arcane Brilliance",
		icon = 135869,
		desc = "+40 Int",
		rank = 2,
		maxRank = true,
	},
	[46302] = { --Sunwell zone buff doesn't stack with int, but is overwritten by fort..
		name = "K'iru's Song of Victory",
		icon = 135981,
		desc = "+40 Int",
		rank = 1,
		maxRank = true,
	},
};

NRC.fort = {
	[1243] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+3 Stam",
		rank = 1,
	},
	[1244] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+8 Stam",
		rank = 2,
	},
	[1245] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+20 Stam",
		rank = 3,
	},
	[2791] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+32 Stam",
		rank = 4,
	},
	[10937] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+43 Stam",
		rank = 5,
	},
	[10938] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+54 Stam",
		rank = 6,
	},
	[25389] = {
		name = "Power Word: Fortitude",
		icon = 135987,
		desc = "+79 Stam",
		rank = 7,
		maxRank = true,
	},
	[21562] = {
		name = "Prayer of Fortitude",
		icon = 135941,
		desc = "+43 Stam",
		rank = 1,
	},
	[21564] = {
		name = "Prayer of Fortitude",
		icon = 135941,
		desc = "+54 Stam",
		rank = 2,
	},
	[25392] = {
		name = "Prayer of Fortitude",
		icon = 135941,
		desc = "+79 Stam",
		rank = 3,
		maxRank = true,
	},
};

NRC.spirit = {
	[14752] = {
		name = "Divine Spirit",
		icon = 135898,
		desc = "+17 Spirit",
		rank = 1,
	},
	[14818] = {
		name = "Divine Spirit",
		icon = 135898,
		desc = "+17 Spirit",
		rank = 2,
	},
	[14819] = {
		name = "Divine Spirit",
		icon = 135898,
		desc = "+33 Spirit",
		rank = 3,
	},
	[27841] = {
		name = "Divine Spirit",
		icon = 135898,
		desc = "+40 Spirit",
		rank = 4,
	},
	[25312] = {
		name = "Divine Spirit",
		icon = 135898,
		desc = "+50 Spirit",
		rank = 5,
		maxRank = true,
	},
	[27681] = {
		name = "Prayer of Spirit",
		icon = 135946,
		desc = "+40 Spirit",
		rank = 1,
	},
	[32999] = {
		name = "Prayer of Spirit",
		icon = 135946,
		desc = "+50 Spirit",
		rank = 2,
		maxRank = true,
	},
};

NRC.shadow = {
	[976] = {
		name = "Shadow Protection",
		icon = 136121,
		desc = "+30 Shadow Resistance",
		rank = 1,
	},
	[10957] = {
		name = "Shadow Protection",
		icon = 136121,
		desc = "+45 Shadow Resistance",
		rank = 2,
	},
	[10958] = {
		name = "Shadow Protection",
		icon = 136121,
		desc = "+60 Shadow Resistance",
		rank = 3,
	},
	[25433] = {
		name = "Shadow Protection",
		icon = 136121,
		desc = "+70 Shadow Resistance",
		rank = 4,
		maxRank = true,
	},
	[27683] = {
		name = "Prayer of Shadow Protection",
		icon = 135945,
		desc = "+60 Shadow Resistance",
		rank = 1,
	},
	[39374] = {
		name = "Prayer of Shadow Protection",
		icon = 135945,
		desc = "+70 Shadow Resistance",
		rank = 2,
		maxRank = true,
	},
};


NRC.motw = {
	[1126] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+25 Armor",
		rank = 1,
	},
	[5232] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+2 Stats, +65 Armor",
		rank = 2,
	},
	[6756] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+4 Stats, +105 Armor",
		rank = 3,
	},
	[5234] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+6 Stats, +150 Armor, +5 Resistances",
		rank = 4,
	},
	[8907] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+8 Stats, +195 Armor, +10 Resistances",
		rank = 5,
	},
	[9884] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+10 Stats, +240 Armor, +15 Resistances",
		rank = 6,
	},
	[9885] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+12 Stats, +285 Armor, +20 Resistances",
		rank = 7,
	},
	[26990] = {
		name = "Mark of the Wild",
		icon = 136078,
		desc = "+14 Stats, +350 Armor, +25 Resistances",
		rank = 8,
		maxRank = true,
	},
	[21849] = {
		name = "Gift of the Wild",
		icon = 136038,
		desc = "+10 Stats, +240 Armor, +15 Resistances",
		rank = 1,
	},
	[21850] = {
		name = "Gift of the Wild",
		icon = 136038,
		desc = "+12 Stats, +285 Armor, +20 Resistances",
		rank = 2,
	},
	[26991] = {
		name = "Gift of the Wild",
		icon = 136038,
		desc = "+14 Stats, +350 Armor, +25 Resistances",
		rank = 3,
		maxRank = true,
	},
};

NRC.pal = {
	--Salv.
	[1038] = {
		name = "Blessing of Salvation",
		icon = 135967,
		desc = "-30% Threat",
		maxRank = true,
		order = 1,
	},
	[25895] = {
		name = "Greater Blessing of Salvation",
		icon = 135910,
		desc = "-30% Threat",
		maxRank = true,
		order = 1,
	},
	--Kings.
	[20217] = {
		name = "Blessing of Kings",
		icon = 135995,
		desc = "+10% Stats",
		maxRank = true,
		order = 2,
	},
	[25898] = {
		name = "Greater Blessing of Kings",
		icon = 135993,
		desc = "+10% Stats",
		maxRank = true,
		order = 2,
	},
	--Might.
	[19740] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+20 Attack Power",
		rank = 1,
		order = 3,
	},
	[19834] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+35 Attack Power",
		rank = 2,
		order = 3,
	},
	[19835] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+55 Attack Power",
		rank = 3,
		order = 3,
	},
	[19836] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+85 Attack Power",
		rank = 4,
		order = 3,
	},
	[19837] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+115 Attack Power",
		rank = 5,
		order = 3,
	},
	[19838] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+155 Attack Power",
		rank = 6,
		order = 3,
	},
	[25291] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+185 Attack Power",
		rank = 7,
		order = 3,
	},
	[27140] = {
		name = "Blessing of Might",
		icon = 135906,
		desc = "+220 Attack Power",
		rank = 8,
		maxRank = true,
		order = 3,
	},
	[25782] = {
		name = "Greater Blessing of Might",
		icon = 135908,
		desc = "+155 Attack Power",
		rank = 1,
		order = 3,
	},
	[25916] = {
		name = "Greater Blessing of Might",
		icon = 135908,
		desc = "+185 Attack Power",
		rank = 2,
		order = 3,
	},
	[27141] = {
		name = "Greater Blessing of Might",
		icon = 135908,
		desc = "+220 Attack Power",
		rank = 3,
		maxRank = true,
		order = 3,
	},
	--Wisdom.
	[19742] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+10 MP5",
		rank = 1,
		order = 4,
	},
	[19850] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+15 MP5",
		rank = 2,
		order = 4,
	},
	[19852] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+20 MP5",
		rank = 3,
		order = 4,
	},
	[19853] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+25 MP5",
		rank = 4,
		order = 4,
	},
	[19854] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+30 MP5",
		rank = 5,
		order = 4,
	},
	[25290] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+33 MP5",
		rank = 6,
		order = 4,
	},
	[27142] = {
		name = "Blessing of Wisdom",
		icon = 135970,
		desc = "+41 MP5",
		rank = 7,
		maxRank = true,
		order = 4,
	},
	[25894] = {
		name = "Greater Blessing of Wisdom",
		icon = 135912,
		desc = "+30 MP5",
		rank = 1,
		order = 4,
	},
	[25918] = {
		name = "Greater Blessing of Wisdom",
		icon = 135912,
		desc = "+33 MP5",
		rank = 2,
		order = 4,
	},
	[27143] = {
		name = "Greater Blessing of Wisdom",
		icon = 135912,
		desc = "+41 MP5",
		rank = 3,
		maxRank = true,
		order = 4,
	},
	--Light.
	[19977] = {
		name = "Blessing of Light",
		icon = 135943,
		desc = "+210 Holy Light, +60 Flash of Light",
		rank = 1,
		order = 5,
	},
	[19977] = {
		name = "Blessing of Light",
		icon = 135943,
		desc = "+300 Holy Light, +85 Flash of Light",
		rank = 2,
		order = 5,
	},
	[19977] = {
		name = "Blessing of Light",
		icon = 135943,
		desc = "+400 Holy Light, +115 Flash of Light",
		rank = 3,
		order = 5,
	},
	[19977] = {
		name = "Blessing of Light",
		icon = 135943,
		desc = "+580 Holy Light, +185 Flash of Light",
		rank = 4,
		maxRank = true,
		order = 5,
	},
	[25890] = {
		name = "Greater Blessing of Light",
		icon = 135909,
		desc = "+400 Holy Light, +115 Flash of Light",
		rank = 1,
		order = 5,
	},
	[27145] = {
		name = "Greater Blessing of Light",
		icon = 135909,
		desc = "+580 Holy Light, +185 Flash of Light",
		rank = 2,
		maxRank = true,
		order = 5,
	},
	--Sanctuary.
	[20911] = {
		name = "Blessing of Sanctuary",
		icon = 136051,
		desc = "-10 Damage Taken, +14 Shield Block Damage",
		rank = 1,
		order = 6,
	},
	[20912] = {
		name = "Blessing of Sanctuary",
		icon = 136051,
		desc = "-14 Damage Taken, +21 Shield Block Damage",
		rank = 2,
		order = 6,
	},
	[20913] = {
		name = "Blessing of Sanctuary",
		icon = 136051,
		desc = "-19 Damage Taken, +28 Shield Block Damage",
		rank = 3,
		order = 6,
	},
	[20914] = {
		name = "Blessing of Sanctuary",
		icon = 136051,
		desc = "-24 Damage Taken, +35 Shield Block Damage",
		rank = 4,
		order = 6,
	},
	[27168] = {
		name = "Blessing of Sanctuary",
		icon = 136051,
		desc = "-80 Damage Taken, +46 Shield Block Damage",
		rank = 5,
		maxRank = true,
		order = 6,
	},
	[25899] = {
		name = "Greater Blessing of Sanctuary",
		icon = 135911,
		desc = "-24 Damage Taken, +35 Shield Block Damage",
		rank = 1,
		order = 6,
	},
	[27169] = {
		name = "Greater Blessing of Sanctuary",
		icon = 135911,
		desc = "-80 Damage Taken, +46 Shield Block Damage",
		rank = 2,
		maxRank = true,
		order = 6,
	},
};